/* Copyright 2009 Patrick Higgins 
 *
 * This file is part of VladNput.
 *
 * VladNput is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * VladNput is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with VladNput.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.vladnput;

import java.util.List;
import java.util.regex.Pattern;

class URLMatchValidator extends BaseURLValidator {
	
	// this class is immutable for thread safety
	
	private final Pattern pattern;
	
    URLMatchValidator(Pattern pattern, List<ParamValidator> param, List<ParamMatchValidator> paramMatch) {
    	super(param, paramMatch);
		this.pattern = pattern;
	}
    
    Pattern getPattern() {
    	return pattern;
    }

	StringBuffer toString(StringBuffer b, int indent) {
		VladUtil.indent(b, indent);
		b.append("URLMatchValidator: ").append(pattern.pattern()).append("\n");
		return super.toString(b, indent+1);
	}
	
	public String toString() {
		return "URLMatchValidator:"+pattern.pattern();
	}

}
