/* Copyright 2009 Patrick Higgins 
 *
 * This file is part of VladNput.
 *
 * VladNput is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * VladNput is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with VladNput.  If not, see <http://www.gnu.org/licenses/>.
 */
// $ANTLR 3.1.3 Mar 17, 2009 19:23:44 VladNput/src/org/vladnput/VladLexer.g 2009-10-23 16:08:47

package org.vladnput;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class VladLexer extends Lexer {
    public static final int STAR=21;
    public static final int RBRACE=24;
    public static final int DOUBLEQUOTED_STRING=29;
    public static final int PARAM_MATCH=9;
    public static final int LBRACE=23;
    public static final int PARAM=8;
    public static final int INT=33;
    public static final int FLOAT=32;
    public static final int EQUALS=19;
    public static final int ID=31;
    public static final int EOF=-1;
    public static final int TRUE=10;
    public static final int SEMI=16;
    public static final int URL=12;
    public static final int LPAREN=18;
    public static final int TYPE=11;
    public static final int ML_COMMENT=36;
    public static final int RPAREN=17;
    public static final int WS=34;
    public static final int QUESTION=20;
    public static final int URL_MATCH=13;
    public static final int COMMA=14;
    public static final int ANGLE_STRING=30;
    public static final int CARET=25;
    public static final int INCLUDE=5;
    public static final int SL_COMMENT=35;
    public static final int PLUS=22;
    public static final int MESSAGE_DEFAULTS=6;
    public static final int DOT=15;
    public static final int URL_LITERAL=26;
    public static final int FALSE=4;
    public static final int EscapeSequence=28;
    public static final int SINGLEQUOTED_STRING=27;
    public static final int OPTIONS=7;


    private ParseErrors parseErrors = null;

    public void setParseErrors(ParseErrors parseErrors) {
        this.parseErrors = parseErrors;
    }

    public String getErrorHeader(RecognitionException e) {
        return VladUtil.getSourceLocation(e);
    }

    public void emitErrorMessage(String msg) {
        parseErrors.add(msg);
    }



    // delegates
    // delegators

    public VladLexer() {;} 
    public VladLexer(CharStream input) {
        this(input, new RecognizerSharedState());
    }
    public VladLexer(CharStream input, RecognizerSharedState state) {
        super(input,state);

    }
    public String getGrammarFileName() { return "VladNput/src/org/vladnput/VladLexer.g"; }

    // $ANTLR start "FALSE"
    public final void mFALSE() throws RecognitionException {
        try {
            int _type = FALSE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:25:7: ( 'false' )
            // VladNput/src/org/vladnput/VladLexer.g:25:9: 'false'
            {
            match("false"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FALSE"

    // $ANTLR start "INCLUDE"
    public final void mINCLUDE() throws RecognitionException {
        try {
            int _type = INCLUDE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:26:9: ( 'include' )
            // VladNput/src/org/vladnput/VladLexer.g:26:11: 'include'
            {
            match("include"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "INCLUDE"

    // $ANTLR start "MESSAGE_DEFAULTS"
    public final void mMESSAGE_DEFAULTS() throws RecognitionException {
        try {
            int _type = MESSAGE_DEFAULTS;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:27:18: ( 'message_defaults' )
            // VladNput/src/org/vladnput/VladLexer.g:27:20: 'message_defaults'
            {
            match("message_defaults"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "MESSAGE_DEFAULTS"

    // $ANTLR start "OPTIONS"
    public final void mOPTIONS() throws RecognitionException {
        try {
            int _type = OPTIONS;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:28:9: ( 'options' )
            // VladNput/src/org/vladnput/VladLexer.g:28:11: 'options'
            {
            match("options"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "OPTIONS"

    // $ANTLR start "PARAM"
    public final void mPARAM() throws RecognitionException {
        try {
            int _type = PARAM;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:29:7: ( 'param' )
            // VladNput/src/org/vladnput/VladLexer.g:29:9: 'param'
            {
            match("param"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "PARAM"

    // $ANTLR start "PARAM_MATCH"
    public final void mPARAM_MATCH() throws RecognitionException {
        try {
            int _type = PARAM_MATCH;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:30:13: ( 'param_match' )
            // VladNput/src/org/vladnput/VladLexer.g:30:15: 'param_match'
            {
            match("param_match"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "PARAM_MATCH"

    // $ANTLR start "TRUE"
    public final void mTRUE() throws RecognitionException {
        try {
            int _type = TRUE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:31:6: ( 'true' )
            // VladNput/src/org/vladnput/VladLexer.g:31:8: 'true'
            {
            match("true"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "TRUE"

    // $ANTLR start "TYPE"
    public final void mTYPE() throws RecognitionException {
        try {
            int _type = TYPE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:32:6: ( 'type' )
            // VladNput/src/org/vladnput/VladLexer.g:32:8: 'type'
            {
            match("type"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "TYPE"

    // $ANTLR start "URL"
    public final void mURL() throws RecognitionException {
        try {
            int _type = URL;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:33:5: ( 'url' )
            // VladNput/src/org/vladnput/VladLexer.g:33:7: 'url'
            {
            match("url"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "URL"

    // $ANTLR start "URL_MATCH"
    public final void mURL_MATCH() throws RecognitionException {
        try {
            int _type = URL_MATCH;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:34:11: ( 'url_match' )
            // VladNput/src/org/vladnput/VladLexer.g:34:13: 'url_match'
            {
            match("url_match"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "URL_MATCH"

    // $ANTLR start "COMMA"
    public final void mCOMMA() throws RecognitionException {
        try {
            int _type = COMMA;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:35:7: ( ',' )
            // VladNput/src/org/vladnput/VladLexer.g:35:9: ','
            {
            match(','); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "COMMA"

    // $ANTLR start "DOT"
    public final void mDOT() throws RecognitionException {
        try {
            int _type = DOT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:36:5: ( '.' )
            // VladNput/src/org/vladnput/VladLexer.g:36:7: '.'
            {
            match('.'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "DOT"

    // $ANTLR start "SEMI"
    public final void mSEMI() throws RecognitionException {
        try {
            int _type = SEMI;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:37:6: ( ';' )
            // VladNput/src/org/vladnput/VladLexer.g:37:8: ';'
            {
            match(';'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "SEMI"

    // $ANTLR start "RPAREN"
    public final void mRPAREN() throws RecognitionException {
        try {
            int _type = RPAREN;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:38:8: ( ')' )
            // VladNput/src/org/vladnput/VladLexer.g:38:10: ')'
            {
            match(')'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RPAREN"

    // $ANTLR start "LPAREN"
    public final void mLPAREN() throws RecognitionException {
        try {
            int _type = LPAREN;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:39:8: ( '(' )
            // VladNput/src/org/vladnput/VladLexer.g:39:10: '('
            {
            match('('); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "LPAREN"

    // $ANTLR start "EQUALS"
    public final void mEQUALS() throws RecognitionException {
        try {
            int _type = EQUALS;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:40:8: ( '=' )
            // VladNput/src/org/vladnput/VladLexer.g:40:10: '='
            {
            match('='); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "EQUALS"

    // $ANTLR start "QUESTION"
    public final void mQUESTION() throws RecognitionException {
        try {
            int _type = QUESTION;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:41:10: ( '?' )
            // VladNput/src/org/vladnput/VladLexer.g:41:12: '?'
            {
            match('?'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "QUESTION"

    // $ANTLR start "STAR"
    public final void mSTAR() throws RecognitionException {
        try {
            int _type = STAR;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:42:6: ( '*' )
            // VladNput/src/org/vladnput/VladLexer.g:42:8: '*'
            {
            match('*'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "STAR"

    // $ANTLR start "PLUS"
    public final void mPLUS() throws RecognitionException {
        try {
            int _type = PLUS;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:43:6: ( '+' )
            // VladNput/src/org/vladnput/VladLexer.g:43:8: '+'
            {
            match('+'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "PLUS"

    // $ANTLR start "LBRACE"
    public final void mLBRACE() throws RecognitionException {
        try {
            int _type = LBRACE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:44:8: ( '{' )
            // VladNput/src/org/vladnput/VladLexer.g:44:10: '{'
            {
            match('{'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "LBRACE"

    // $ANTLR start "RBRACE"
    public final void mRBRACE() throws RecognitionException {
        try {
            int _type = RBRACE;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:45:8: ( '}' )
            // VladNput/src/org/vladnput/VladLexer.g:45:10: '}'
            {
            match('}'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RBRACE"

    // $ANTLR start "CARET"
    public final void mCARET() throws RecognitionException {
        try {
            int _type = CARET;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:46:7: ( '^' )
            // VladNput/src/org/vladnput/VladLexer.g:46:9: '^'
            {
            match('^'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "CARET"

    // $ANTLR start "URL_LITERAL"
    public final void mURL_LITERAL() throws RecognitionException {
        try {
            int _type = URL_LITERAL;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:48:2: ( ( '/' ( 'a' .. 'z' | 'A' .. 'Z' | '0' .. '9' | '_' | '.' )+ )+ )
            // VladNput/src/org/vladnput/VladLexer.g:48:4: ( '/' ( 'a' .. 'z' | 'A' .. 'Z' | '0' .. '9' | '_' | '.' )+ )+
            {
            // VladNput/src/org/vladnput/VladLexer.g:48:4: ( '/' ( 'a' .. 'z' | 'A' .. 'Z' | '0' .. '9' | '_' | '.' )+ )+
            int cnt2=0;
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0=='/') ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladLexer.g:48:6: '/' ( 'a' .. 'z' | 'A' .. 'Z' | '0' .. '9' | '_' | '.' )+
            	    {
            	    match('/'); 
            	    // VladNput/src/org/vladnput/VladLexer.g:48:10: ( 'a' .. 'z' | 'A' .. 'Z' | '0' .. '9' | '_' | '.' )+
            	    int cnt1=0;
            	    loop1:
            	    do {
            	        int alt1=2;
            	        int LA1_0 = input.LA(1);

            	        if ( (LA1_0=='.'||(LA1_0>='0' && LA1_0<='9')||(LA1_0>='A' && LA1_0<='Z')||LA1_0=='_'||(LA1_0>='a' && LA1_0<='z')) ) {
            	            alt1=1;
            	        }


            	        switch (alt1) {
            	    	case 1 :
            	    	    // VladNput/src/org/vladnput/VladLexer.g:
            	    	    {
            	    	    if ( input.LA(1)=='.'||(input.LA(1)>='0' && input.LA(1)<='9')||(input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
            	    	        input.consume();

            	    	    }
            	    	    else {
            	    	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	    	        recover(mse);
            	    	        throw mse;}


            	    	    }
            	    	    break;

            	    	default :
            	    	    if ( cnt1 >= 1 ) break loop1;
            	                EarlyExitException eee =
            	                    new EarlyExitException(1, input);
            	                throw eee;
            	        }
            	        cnt1++;
            	    } while (true);


            	    }
            	    break;

            	default :
            	    if ( cnt2 >= 1 ) break loop2;
                        EarlyExitException eee =
                            new EarlyExitException(2, input);
                        throw eee;
                }
                cnt2++;
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "URL_LITERAL"

    // $ANTLR start "SINGLEQUOTED_STRING"
    public final void mSINGLEQUOTED_STRING() throws RecognitionException {
        try {
            int _type = SINGLEQUOTED_STRING;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:51:2: ( '\\'' ( options {greedy=false; } : . )* '\\'' )
            // VladNput/src/org/vladnput/VladLexer.g:51:4: '\\'' ( options {greedy=false; } : . )* '\\''
            {
            match('\''); 
            // VladNput/src/org/vladnput/VladLexer.g:51:9: ( options {greedy=false; } : . )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0=='\'') ) {
                    alt3=2;
                }
                else if ( ((LA3_0>='\u0000' && LA3_0<='&')||(LA3_0>='(' && LA3_0<='\uFFFF')) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladLexer.g:51:37: .
            	    {
            	    matchAny(); 

            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);

            match('\''); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "SINGLEQUOTED_STRING"

    // $ANTLR start "DOUBLEQUOTED_STRING"
    public final void mDOUBLEQUOTED_STRING() throws RecognitionException {
        try {
            int _type = DOUBLEQUOTED_STRING;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:54:2: ( '\"' ( EscapeSequence | ~ ( '\\\\' | '\"' | '\\r' | '\\n' ) )* '\"' )
            // VladNput/src/org/vladnput/VladLexer.g:54:4: '\"' ( EscapeSequence | ~ ( '\\\\' | '\"' | '\\r' | '\\n' ) )* '\"'
            {
            match('\"'); 
            // VladNput/src/org/vladnput/VladLexer.g:55:3: ( EscapeSequence | ~ ( '\\\\' | '\"' | '\\r' | '\\n' ) )*
            loop4:
            do {
                int alt4=3;
                int LA4_0 = input.LA(1);

                if ( (LA4_0=='\\') ) {
                    alt4=1;
                }
                else if ( ((LA4_0>='\u0000' && LA4_0<='\t')||(LA4_0>='\u000B' && LA4_0<='\f')||(LA4_0>='\u000E' && LA4_0<='!')||(LA4_0>='#' && LA4_0<='[')||(LA4_0>=']' && LA4_0<='\uFFFF')) ) {
                    alt4=2;
                }


                switch (alt4) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladLexer.g:55:5: EscapeSequence
            	    {
            	    mEscapeSequence(); 

            	    }
            	    break;
            	case 2 :
            	    // VladNput/src/org/vladnput/VladLexer.g:56:5: ~ ( '\\\\' | '\"' | '\\r' | '\\n' )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='!')||(input.LA(1)>='#' && input.LA(1)<='[')||(input.LA(1)>=']' && input.LA(1)<='\uFFFF') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    break loop4;
                }
            } while (true);

            match('\"'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "DOUBLEQUOTED_STRING"

    // $ANTLR start "EscapeSequence"
    public final void mEscapeSequence() throws RecognitionException {
        try {
            // VladNput/src/org/vladnput/VladLexer.g:61:2: ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | '\\\"' | '\\'' | '\\\\' | ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' ) | ( '0' .. '7' ) ( '0' .. '7' ) | ( '0' .. '7' ) ) )
            // VladNput/src/org/vladnput/VladLexer.g:61:4: '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | '\\\"' | '\\'' | '\\\\' | ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' ) | ( '0' .. '7' ) ( '0' .. '7' ) | ( '0' .. '7' ) )
            {
            match('\\'); 
            // VladNput/src/org/vladnput/VladLexer.g:61:9: ( 'b' | 't' | 'n' | 'f' | 'r' | '\\\"' | '\\'' | '\\\\' | ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' ) | ( '0' .. '7' ) ( '0' .. '7' ) | ( '0' .. '7' ) )
            int alt5=11;
            alt5 = dfa5.predict(input);
            switch (alt5) {
                case 1 :
                    // VladNput/src/org/vladnput/VladLexer.g:62:5: 'b'
                    {
                    match('b'); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladLexer.g:63:6: 't'
                    {
                    match('t'); 

                    }
                    break;
                case 3 :
                    // VladNput/src/org/vladnput/VladLexer.g:64:6: 'n'
                    {
                    match('n'); 

                    }
                    break;
                case 4 :
                    // VladNput/src/org/vladnput/VladLexer.g:65:6: 'f'
                    {
                    match('f'); 

                    }
                    break;
                case 5 :
                    // VladNput/src/org/vladnput/VladLexer.g:66:6: 'r'
                    {
                    match('r'); 

                    }
                    break;
                case 6 :
                    // VladNput/src/org/vladnput/VladLexer.g:67:6: '\\\"'
                    {
                    match('\"'); 

                    }
                    break;
                case 7 :
                    // VladNput/src/org/vladnput/VladLexer.g:68:6: '\\''
                    {
                    match('\''); 

                    }
                    break;
                case 8 :
                    // VladNput/src/org/vladnput/VladLexer.g:69:6: '\\\\'
                    {
                    match('\\'); 

                    }
                    break;
                case 9 :
                    // VladNput/src/org/vladnput/VladLexer.g:70:6: ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' )
                    {
                    // VladNput/src/org/vladnput/VladLexer.g:70:6: ( '0' .. '3' )
                    // VladNput/src/org/vladnput/VladLexer.g:70:7: '0' .. '3'
                    {
                    matchRange('0','3'); 

                    }

                    // VladNput/src/org/vladnput/VladLexer.g:70:17: ( '0' .. '7' )
                    // VladNput/src/org/vladnput/VladLexer.g:70:18: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }

                    // VladNput/src/org/vladnput/VladLexer.g:70:28: ( '0' .. '7' )
                    // VladNput/src/org/vladnput/VladLexer.g:70:29: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }


                    }
                    break;
                case 10 :
                    // VladNput/src/org/vladnput/VladLexer.g:71:6: ( '0' .. '7' ) ( '0' .. '7' )
                    {
                    // VladNput/src/org/vladnput/VladLexer.g:71:6: ( '0' .. '7' )
                    // VladNput/src/org/vladnput/VladLexer.g:71:7: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }

                    // VladNput/src/org/vladnput/VladLexer.g:71:17: ( '0' .. '7' )
                    // VladNput/src/org/vladnput/VladLexer.g:71:18: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }


                    }
                    break;
                case 11 :
                    // VladNput/src/org/vladnput/VladLexer.g:72:6: ( '0' .. '7' )
                    {
                    // VladNput/src/org/vladnput/VladLexer.g:72:6: ( '0' .. '7' )
                    // VladNput/src/org/vladnput/VladLexer.g:72:7: '0' .. '7'
                    {
                    matchRange('0','7'); 

                    }


                    }
                    break;

            }


            }

        }
        finally {
        }
    }
    // $ANTLR end "EscapeSequence"

    // $ANTLR start "ANGLE_STRING"
    public final void mANGLE_STRING() throws RecognitionException {
        try {
            int _type = ANGLE_STRING;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:76:2: ( '<' ( options {greedy=false; } : . )* '>' )
            // VladNput/src/org/vladnput/VladLexer.g:76:4: '<' ( options {greedy=false; } : . )* '>'
            {
            match('<'); 
            // VladNput/src/org/vladnput/VladLexer.g:76:8: ( options {greedy=false; } : . )*
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( (LA6_0=='>') ) {
                    alt6=2;
                }
                else if ( ((LA6_0>='\u0000' && LA6_0<='=')||(LA6_0>='?' && LA6_0<='\uFFFF')) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladLexer.g:76:36: .
            	    {
            	    matchAny(); 

            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);

            match('>'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "ANGLE_STRING"

    // $ANTLR start "ID"
    public final void mID() throws RecognitionException {
        try {
            int _type = ID;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:78:4: ( ( 'a' .. 'z' | 'A' .. 'Z' | '_' ) ( 'a' .. 'z' | 'A' .. 'Z' | '0' .. '9' | '_' )* )
            // VladNput/src/org/vladnput/VladLexer.g:78:6: ( 'a' .. 'z' | 'A' .. 'Z' | '_' ) ( 'a' .. 'z' | 'A' .. 'Z' | '0' .. '9' | '_' )*
            {
            if ( (input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}

            // VladNput/src/org/vladnput/VladLexer.g:79:3: ( 'a' .. 'z' | 'A' .. 'Z' | '0' .. '9' | '_' )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( ((LA7_0>='0' && LA7_0<='9')||(LA7_0>='A' && LA7_0<='Z')||LA7_0=='_'||(LA7_0>='a' && LA7_0<='z')) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladLexer.g:
            	    {
            	    if ( (input.LA(1)>='0' && input.LA(1)<='9')||(input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "ID"

    // $ANTLR start "FLOAT"
    public final void mFLOAT() throws RecognitionException {
        try {
            int _type = FLOAT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:82:2: ( ( '-' )? '0' .. '9' '.' ( '0' .. '9' )+ )
            // VladNput/src/org/vladnput/VladLexer.g:82:4: ( '-' )? '0' .. '9' '.' ( '0' .. '9' )+
            {
            // VladNput/src/org/vladnput/VladLexer.g:82:4: ( '-' )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0=='-') ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // VladNput/src/org/vladnput/VladLexer.g:82:4: '-'
                    {
                    match('-'); 

                    }
                    break;

            }

            matchRange('0','9'); 
            match('.'); 
            // VladNput/src/org/vladnput/VladLexer.g:82:24: ( '0' .. '9' )+
            int cnt9=0;
            loop9:
            do {
                int alt9=2;
                int LA9_0 = input.LA(1);

                if ( ((LA9_0>='0' && LA9_0<='9')) ) {
                    alt9=1;
                }


                switch (alt9) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladLexer.g:82:26: '0' .. '9'
            	    {
            	    matchRange('0','9'); 

            	    }
            	    break;

            	default :
            	    if ( cnt9 >= 1 ) break loop9;
                        EarlyExitException eee =
                            new EarlyExitException(9, input);
                        throw eee;
                }
                cnt9++;
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "FLOAT"

    // $ANTLR start "INT"
    public final void mINT() throws RecognitionException {
        try {
            int _type = INT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:85:2: ( ( '-' )? ( '0' .. '9' )+ )
            // VladNput/src/org/vladnput/VladLexer.g:85:4: ( '-' )? ( '0' .. '9' )+
            {
            // VladNput/src/org/vladnput/VladLexer.g:85:4: ( '-' )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0=='-') ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // VladNput/src/org/vladnput/VladLexer.g:85:4: '-'
                    {
                    match('-'); 

                    }
                    break;

            }

            // VladNput/src/org/vladnput/VladLexer.g:85:9: ( '0' .. '9' )+
            int cnt11=0;
            loop11:
            do {
                int alt11=2;
                int LA11_0 = input.LA(1);

                if ( ((LA11_0>='0' && LA11_0<='9')) ) {
                    alt11=1;
                }


                switch (alt11) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladLexer.g:85:11: '0' .. '9'
            	    {
            	    matchRange('0','9'); 

            	    }
            	    break;

            	default :
            	    if ( cnt11 >= 1 ) break loop11;
                        EarlyExitException eee =
                            new EarlyExitException(11, input);
                        throw eee;
                }
                cnt11++;
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "INT"

    // $ANTLR start "WS"
    public final void mWS() throws RecognitionException {
        try {
            int _type = WS;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:87:4: ( ( ' ' | '\\r' | '\\t' | '\\n' ) )
            // VladNput/src/org/vladnput/VladLexer.g:87:6: ( ' ' | '\\r' | '\\t' | '\\n' )
            {
            if ( (input.LA(1)>='\t' && input.LA(1)<='\n')||input.LA(1)=='\r'||input.LA(1)==' ' ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}

            _channel=HIDDEN;

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "WS"

    // $ANTLR start "SL_COMMENT"
    public final void mSL_COMMENT() throws RecognitionException {
        try {
            int _type = SL_COMMENT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:90:2: ( '//' (~ ( '\\n' | '\\r' ) )* ( '\\r' )? '\\n' )
            // VladNput/src/org/vladnput/VladLexer.g:90:4: '//' (~ ( '\\n' | '\\r' ) )* ( '\\r' )? '\\n'
            {
            match("//"); 

            // VladNput/src/org/vladnput/VladLexer.g:90:9: (~ ( '\\n' | '\\r' ) )*
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( ((LA12_0>='\u0000' && LA12_0<='\t')||(LA12_0>='\u000B' && LA12_0<='\f')||(LA12_0>='\u000E' && LA12_0<='\uFFFF')) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladLexer.g:90:9: ~ ( '\\n' | '\\r' )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='\uFFFF') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);

            // VladNput/src/org/vladnput/VladLexer.g:90:23: ( '\\r' )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0=='\r') ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // VladNput/src/org/vladnput/VladLexer.g:90:23: '\\r'
                    {
                    match('\r'); 

                    }
                    break;

            }

            match('\n'); 
            _channel=HIDDEN;

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "SL_COMMENT"

    // $ANTLR start "ML_COMMENT"
    public final void mML_COMMENT() throws RecognitionException {
        try {
            int _type = ML_COMMENT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // VladNput/src/org/vladnput/VladLexer.g:93:2: ( '/*' ( options {greedy=false; } : . )* '*/' )
            // VladNput/src/org/vladnput/VladLexer.g:93:4: '/*' ( options {greedy=false; } : . )* '*/'
            {
            match("/*"); 

            // VladNput/src/org/vladnput/VladLexer.g:93:9: ( options {greedy=false; } : . )*
            loop14:
            do {
                int alt14=2;
                int LA14_0 = input.LA(1);

                if ( (LA14_0=='*') ) {
                    int LA14_1 = input.LA(2);

                    if ( (LA14_1=='/') ) {
                        alt14=2;
                    }
                    else if ( ((LA14_1>='\u0000' && LA14_1<='.')||(LA14_1>='0' && LA14_1<='\uFFFF')) ) {
                        alt14=1;
                    }


                }
                else if ( ((LA14_0>='\u0000' && LA14_0<=')')||(LA14_0>='+' && LA14_0<='\uFFFF')) ) {
                    alt14=1;
                }


                switch (alt14) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladLexer.g:93:37: .
            	    {
            	    matchAny(); 

            	    }
            	    break;

            	default :
            	    break loop14;
                }
            } while (true);

            match("*/"); 

            _channel=HIDDEN;

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "ML_COMMENT"

    public void mTokens() throws RecognitionException {
        // VladNput/src/org/vladnput/VladLexer.g:1:8: ( FALSE | INCLUDE | MESSAGE_DEFAULTS | OPTIONS | PARAM | PARAM_MATCH | TRUE | TYPE | URL | URL_MATCH | COMMA | DOT | SEMI | RPAREN | LPAREN | EQUALS | QUESTION | STAR | PLUS | LBRACE | RBRACE | CARET | URL_LITERAL | SINGLEQUOTED_STRING | DOUBLEQUOTED_STRING | ANGLE_STRING | ID | FLOAT | INT | WS | SL_COMMENT | ML_COMMENT )
        int alt15=32;
        alt15 = dfa15.predict(input);
        switch (alt15) {
            case 1 :
                // VladNput/src/org/vladnput/VladLexer.g:1:10: FALSE
                {
                mFALSE(); 

                }
                break;
            case 2 :
                // VladNput/src/org/vladnput/VladLexer.g:1:16: INCLUDE
                {
                mINCLUDE(); 

                }
                break;
            case 3 :
                // VladNput/src/org/vladnput/VladLexer.g:1:24: MESSAGE_DEFAULTS
                {
                mMESSAGE_DEFAULTS(); 

                }
                break;
            case 4 :
                // VladNput/src/org/vladnput/VladLexer.g:1:41: OPTIONS
                {
                mOPTIONS(); 

                }
                break;
            case 5 :
                // VladNput/src/org/vladnput/VladLexer.g:1:49: PARAM
                {
                mPARAM(); 

                }
                break;
            case 6 :
                // VladNput/src/org/vladnput/VladLexer.g:1:55: PARAM_MATCH
                {
                mPARAM_MATCH(); 

                }
                break;
            case 7 :
                // VladNput/src/org/vladnput/VladLexer.g:1:67: TRUE
                {
                mTRUE(); 

                }
                break;
            case 8 :
                // VladNput/src/org/vladnput/VladLexer.g:1:72: TYPE
                {
                mTYPE(); 

                }
                break;
            case 9 :
                // VladNput/src/org/vladnput/VladLexer.g:1:77: URL
                {
                mURL(); 

                }
                break;
            case 10 :
                // VladNput/src/org/vladnput/VladLexer.g:1:81: URL_MATCH
                {
                mURL_MATCH(); 

                }
                break;
            case 11 :
                // VladNput/src/org/vladnput/VladLexer.g:1:91: COMMA
                {
                mCOMMA(); 

                }
                break;
            case 12 :
                // VladNput/src/org/vladnput/VladLexer.g:1:97: DOT
                {
                mDOT(); 

                }
                break;
            case 13 :
                // VladNput/src/org/vladnput/VladLexer.g:1:101: SEMI
                {
                mSEMI(); 

                }
                break;
            case 14 :
                // VladNput/src/org/vladnput/VladLexer.g:1:106: RPAREN
                {
                mRPAREN(); 

                }
                break;
            case 15 :
                // VladNput/src/org/vladnput/VladLexer.g:1:113: LPAREN
                {
                mLPAREN(); 

                }
                break;
            case 16 :
                // VladNput/src/org/vladnput/VladLexer.g:1:120: EQUALS
                {
                mEQUALS(); 

                }
                break;
            case 17 :
                // VladNput/src/org/vladnput/VladLexer.g:1:127: QUESTION
                {
                mQUESTION(); 

                }
                break;
            case 18 :
                // VladNput/src/org/vladnput/VladLexer.g:1:136: STAR
                {
                mSTAR(); 

                }
                break;
            case 19 :
                // VladNput/src/org/vladnput/VladLexer.g:1:141: PLUS
                {
                mPLUS(); 

                }
                break;
            case 20 :
                // VladNput/src/org/vladnput/VladLexer.g:1:146: LBRACE
                {
                mLBRACE(); 

                }
                break;
            case 21 :
                // VladNput/src/org/vladnput/VladLexer.g:1:153: RBRACE
                {
                mRBRACE(); 

                }
                break;
            case 22 :
                // VladNput/src/org/vladnput/VladLexer.g:1:160: CARET
                {
                mCARET(); 

                }
                break;
            case 23 :
                // VladNput/src/org/vladnput/VladLexer.g:1:166: URL_LITERAL
                {
                mURL_LITERAL(); 

                }
                break;
            case 24 :
                // VladNput/src/org/vladnput/VladLexer.g:1:178: SINGLEQUOTED_STRING
                {
                mSINGLEQUOTED_STRING(); 

                }
                break;
            case 25 :
                // VladNput/src/org/vladnput/VladLexer.g:1:198: DOUBLEQUOTED_STRING
                {
                mDOUBLEQUOTED_STRING(); 

                }
                break;
            case 26 :
                // VladNput/src/org/vladnput/VladLexer.g:1:218: ANGLE_STRING
                {
                mANGLE_STRING(); 

                }
                break;
            case 27 :
                // VladNput/src/org/vladnput/VladLexer.g:1:231: ID
                {
                mID(); 

                }
                break;
            case 28 :
                // VladNput/src/org/vladnput/VladLexer.g:1:234: FLOAT
                {
                mFLOAT(); 

                }
                break;
            case 29 :
                // VladNput/src/org/vladnput/VladLexer.g:1:240: INT
                {
                mINT(); 

                }
                break;
            case 30 :
                // VladNput/src/org/vladnput/VladLexer.g:1:244: WS
                {
                mWS(); 

                }
                break;
            case 31 :
                // VladNput/src/org/vladnput/VladLexer.g:1:247: SL_COMMENT
                {
                mSL_COMMENT(); 

                }
                break;
            case 32 :
                // VladNput/src/org/vladnput/VladLexer.g:1:258: ML_COMMENT
                {
                mML_COMMENT(); 

                }
                break;

        }

    }


    protected DFA5 dfa5 = new DFA5(this);
    protected DFA15 dfa15 = new DFA15(this);
    static final String DFA5_eotS =
        "\11\uffff\2\14\1\15\3\uffff";
    static final String DFA5_eofS =
        "\17\uffff";
    static final String DFA5_minS =
        "\1\42\10\uffff\3\60\3\uffff";
    static final String DFA5_maxS =
        "\1\164\10\uffff\3\67\3\uffff";
    static final String DFA5_acceptS =
        "\1\uffff\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\3\uffff\1\13\1\12\1\11";
    static final String DFA5_specialS =
        "\17\uffff}>";
    static final String[] DFA5_transitionS = {
            "\1\6\4\uffff\1\7\10\uffff\4\11\4\12\44\uffff\1\10\5\uffff\1"+
            "\1\3\uffff\1\4\7\uffff\1\3\3\uffff\1\5\1\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\10\13",
            "\10\15",
            "\10\16",
            "",
            "",
            ""
    };

    static final short[] DFA5_eot = DFA.unpackEncodedString(DFA5_eotS);
    static final short[] DFA5_eof = DFA.unpackEncodedString(DFA5_eofS);
    static final char[] DFA5_min = DFA.unpackEncodedStringToUnsignedChars(DFA5_minS);
    static final char[] DFA5_max = DFA.unpackEncodedStringToUnsignedChars(DFA5_maxS);
    static final short[] DFA5_accept = DFA.unpackEncodedString(DFA5_acceptS);
    static final short[] DFA5_special = DFA.unpackEncodedString(DFA5_specialS);
    static final short[][] DFA5_transition;

    static {
        int numStates = DFA5_transitionS.length;
        DFA5_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA5_transition[i] = DFA.unpackEncodedString(DFA5_transitionS[i]);
        }
    }

    class DFA5 extends DFA {

        public DFA5(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 5;
            this.eot = DFA5_eot;
            this.eof = DFA5_eof;
            this.min = DFA5_min;
            this.max = DFA5_max;
            this.accept = DFA5_accept;
            this.special = DFA5_special;
            this.transition = DFA5_transition;
        }
        public String getDescription() {
            return "61:9: ( 'b' | 't' | 'n' | 'f' | 'r' | '\\\"' | '\\'' | '\\\\' | ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' ) | ( '0' .. '7' ) ( '0' .. '7' ) | ( '0' .. '7' ) )";
        }
    }
    static final String DFA15_eotS =
        "\1\uffff\7\30\22\uffff\1\50\1\uffff\10\30\5\uffff\7\30\1\71\5\30"+
        "\1\77\1\100\1\30\1\uffff\1\102\3\30\1\107\2\uffff\1\30\1\uffff\4"+
        "\30\1\uffff\1\30\1\116\1\30\1\120\2\30\1\uffff\1\30\1\uffff\4\30"+
        "\1\130\2\30\1\uffff\1\30\1\134\1\30\1\uffff\3\30\1\141\1\uffff";
    static final String DFA15_eofS =
        "\142\uffff";
    static final String DFA15_minS =
        "\1\11\1\141\1\156\1\145\1\160\1\141\2\162\14\uffff\1\52\4\uffff"+
        "\1\60\1\56\1\uffff\1\154\1\143\1\163\1\164\1\162\1\165\1\160\1\154"+
        "\5\uffff\1\163\1\154\1\163\1\151\1\141\2\145\1\60\1\145\1\165\1"+
        "\141\1\157\1\155\2\60\1\155\1\uffff\1\60\1\144\1\147\1\156\1\60"+
        "\2\uffff\1\141\1\uffff\2\145\1\163\1\155\1\uffff\1\164\1\60\1\137"+
        "\1\60\1\141\1\143\1\uffff\1\144\1\uffff\1\164\1\150\1\145\1\143"+
        "\1\60\1\146\1\150\1\uffff\1\141\1\60\1\165\1\uffff\1\154\1\164\1"+
        "\163\1\60\1\uffff";
    static final String DFA15_maxS =
        "\1\175\1\141\1\156\1\145\1\160\1\141\1\171\1\162\14\uffff\1\172"+
        "\4\uffff\1\71\1\56\1\uffff\1\154\1\143\1\163\1\164\1\162\1\165\1"+
        "\160\1\154\5\uffff\1\163\1\154\1\163\1\151\1\141\2\145\1\172\1\145"+
        "\1\165\1\141\1\157\1\155\2\172\1\155\1\uffff\1\172\1\144\1\147\1"+
        "\156\1\172\2\uffff\1\141\1\uffff\2\145\1\163\1\155\1\uffff\1\164"+
        "\1\172\1\137\1\172\1\141\1\143\1\uffff\1\144\1\uffff\1\164\1\150"+
        "\1\145\1\143\1\172\1\146\1\150\1\uffff\1\141\1\172\1\165\1\uffff"+
        "\1\154\1\164\1\163\1\172\1\uffff";
    static final String DFA15_acceptS =
        "\10\uffff\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25"+
        "\1\26\1\uffff\1\30\1\31\1\32\1\33\2\uffff\1\36\10\uffff\1\37\1\40"+
        "\1\27\1\34\1\35\20\uffff\1\11\5\uffff\1\7\1\10\1\uffff\1\1\4\uffff"+
        "\1\5\6\uffff\1\2\1\uffff\1\4\7\uffff\1\12\3\uffff\1\6\4\uffff\1"+
        "\3";
    static final String DFA15_specialS =
        "\142\uffff}>";
    static final String[] DFA15_transitionS = {
            "\2\33\2\uffff\1\33\22\uffff\1\33\1\uffff\1\26\4\uffff\1\25\1"+
            "\14\1\13\1\17\1\20\1\10\1\31\1\11\1\24\12\32\1\uffff\1\12\1"+
            "\27\1\15\1\uffff\1\16\1\uffff\32\30\3\uffff\1\23\1\30\1\uffff"+
            "\5\30\1\1\2\30\1\2\3\30\1\3\1\30\1\4\1\5\3\30\1\6\1\7\5\30\1"+
            "\21\1\uffff\1\22",
            "\1\34",
            "\1\35",
            "\1\36",
            "\1\37",
            "\1\40",
            "\1\41\6\uffff\1\42",
            "\1\43",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\45\3\uffff\1\46\1\44\12\46\7\uffff\32\46\4\uffff\1\46\1"+
            "\uffff\32\46",
            "",
            "",
            "",
            "",
            "\12\32",
            "\1\47",
            "",
            "\1\51",
            "\1\52",
            "\1\53",
            "\1\54",
            "\1\55",
            "\1\56",
            "\1\57",
            "\1\60",
            "",
            "",
            "",
            "",
            "",
            "\1\61",
            "\1\62",
            "\1\63",
            "\1\64",
            "\1\65",
            "\1\66",
            "\1\67",
            "\12\30\7\uffff\32\30\4\uffff\1\70\1\uffff\32\30",
            "\1\72",
            "\1\73",
            "\1\74",
            "\1\75",
            "\1\76",
            "\12\30\7\uffff\32\30\4\uffff\1\30\1\uffff\32\30",
            "\12\30\7\uffff\32\30\4\uffff\1\30\1\uffff\32\30",
            "\1\101",
            "",
            "\12\30\7\uffff\32\30\4\uffff\1\30\1\uffff\32\30",
            "\1\103",
            "\1\104",
            "\1\105",
            "\12\30\7\uffff\32\30\4\uffff\1\106\1\uffff\32\30",
            "",
            "",
            "\1\110",
            "",
            "\1\111",
            "\1\112",
            "\1\113",
            "\1\114",
            "",
            "\1\115",
            "\12\30\7\uffff\32\30\4\uffff\1\30\1\uffff\32\30",
            "\1\117",
            "\12\30\7\uffff\32\30\4\uffff\1\30\1\uffff\32\30",
            "\1\121",
            "\1\122",
            "",
            "\1\123",
            "",
            "\1\124",
            "\1\125",
            "\1\126",
            "\1\127",
            "\12\30\7\uffff\32\30\4\uffff\1\30\1\uffff\32\30",
            "\1\131",
            "\1\132",
            "",
            "\1\133",
            "\12\30\7\uffff\32\30\4\uffff\1\30\1\uffff\32\30",
            "\1\135",
            "",
            "\1\136",
            "\1\137",
            "\1\140",
            "\12\30\7\uffff\32\30\4\uffff\1\30\1\uffff\32\30",
            ""
    };

    static final short[] DFA15_eot = DFA.unpackEncodedString(DFA15_eotS);
    static final short[] DFA15_eof = DFA.unpackEncodedString(DFA15_eofS);
    static final char[] DFA15_min = DFA.unpackEncodedStringToUnsignedChars(DFA15_minS);
    static final char[] DFA15_max = DFA.unpackEncodedStringToUnsignedChars(DFA15_maxS);
    static final short[] DFA15_accept = DFA.unpackEncodedString(DFA15_acceptS);
    static final short[] DFA15_special = DFA.unpackEncodedString(DFA15_specialS);
    static final short[][] DFA15_transition;

    static {
        int numStates = DFA15_transitionS.length;
        DFA15_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA15_transition[i] = DFA.unpackEncodedString(DFA15_transitionS[i]);
        }
    }

    class DFA15 extends DFA {

        public DFA15(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 15;
            this.eot = DFA15_eot;
            this.eof = DFA15_eof;
            this.min = DFA15_min;
            this.max = DFA15_max;
            this.accept = DFA15_accept;
            this.special = DFA15_special;
            this.transition = DFA15_transition;
        }
        public String getDescription() {
            return "1:1: Tokens : ( FALSE | INCLUDE | MESSAGE_DEFAULTS | OPTIONS | PARAM | PARAM_MATCH | TRUE | TYPE | URL | URL_MATCH | COMMA | DOT | SEMI | RPAREN | LPAREN | EQUALS | QUESTION | STAR | PLUS | LBRACE | RBRACE | CARET | URL_LITERAL | SINGLEQUOTED_STRING | DOUBLEQUOTED_STRING | ANGLE_STRING | ID | FLOAT | INT | WS | SL_COMMENT | ML_COMMENT );";
        }
    }
 

}