/* Copyright 2009 Patrick Higgins 
 *
 * This file is part of VladNput.
 *
 * VladNput is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * VladNput is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with VladNput.  If not, see <http://www.gnu.org/licenses/>.
 */
// $ANTLR 3.1.3 Mar 17, 2009 19:23:44 VladNput/src/org/vladnput/VladParser.g 2009-10-23 16:08:39

package org.vladnput;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;


import org.antlr.runtime.tree.*;

public class VladParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "FALSE", "INCLUDE", "MESSAGE_DEFAULTS", "OPTIONS", "PARAM", "PARAM_MATCH", "TRUE", "TYPE", "URL", "URL_MATCH", "COMMA", "DOT", "SEMI", "RPAREN", "LPAREN", "EQUALS", "QUESTION", "STAR", "PLUS", "LBRACE", "RBRACE", "CARET", "URL_LITERAL", "SINGLEQUOTED_STRING", "EscapeSequence", "DOUBLEQUOTED_STRING", "ANGLE_STRING", "ID", "FLOAT", "INT", "WS", "SL_COMMENT", "ML_COMMENT", "EMPTY_ARGS", "KW_ARGS", "NO_ARGS", "NO_BODY", "NO_CARD_SPEC", "OPTION", "QNAME", "URL_BODY"
    };
    public static final int URL_BODY=44;
    public static final int STAR=21;
    public static final int OPTION=42;
    public static final int EMPTY_ARGS=37;
    public static final int PARAM_MATCH=9;
    public static final int LBRACE=23;
    public static final int NO_CARD_SPEC=41;
    public static final int PARAM=8;
    public static final int EQUALS=19;
    public static final int FLOAT=32;
    public static final int ID=31;
    public static final int EOF=-1;
    public static final int LPAREN=18;
    public static final int TYPE=11;
    public static final int ML_COMMENT=36;
    public static final int RPAREN=17;
    public static final int NO_BODY=40;
    public static final int COMMA=14;
    public static final int CARET=25;
    public static final int INCLUDE=5;
    public static final int PLUS=22;
    public static final int DOT=15;
    public static final int URL_LITERAL=26;
    public static final int NO_ARGS=39;
    public static final int RBRACE=24;
    public static final int DOUBLEQUOTED_STRING=29;
    public static final int INT=33;
    public static final int KW_ARGS=38;
    public static final int SEMI=16;
    public static final int TRUE=10;
    public static final int URL=12;
    public static final int WS=34;
    public static final int QNAME=43;
    public static final int QUESTION=20;
    public static final int URL_MATCH=13;
    public static final int ANGLE_STRING=30;
    public static final int SL_COMMENT=35;
    public static final int MESSAGE_DEFAULTS=6;
    public static final int FALSE=4;
    public static final int EscapeSequence=28;
    public static final int SINGLEQUOTED_STRING=27;
    public static final int OPTIONS=7;

    // delegates
    // delegators


        public VladParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public VladParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return VladParser.tokenNames; }
    public String getGrammarFileName() { return "VladNput/src/org/vladnput/VladParser.g"; }



    private final static boolean DEBUG = false;

    private ParseErrors parseErrors = null;

    public void setParseErrors(ParseErrors parseErrors) {
        this.parseErrors = parseErrors;
    }

    public String getErrorHeader(RecognitionException e) {
        return VladUtil.getSourceLocation(e);
    }

    public void emitErrorMessage(String msg) {
        parseErrors.add(msg);
    }

    public String getErrorMessage(RecognitionException e, String[] tokenNames) {
        if (DEBUG) {
            List stack = getRuleInvocationStack(e, this.getClass().getName());
            String msg = null;
            if (e instanceof NoViableAltException) {
                NoViableAltException nvae = (NoViableAltException) e;
                msg = " no viable alt; token="+e.token+
                      " (decision="+nvae.decisionNumber+
                      " state "+nvae.stateNumber+")"+
                      " decision=<<"+nvae.grammarDecisionDescription+">>";
            }
            else {
                msg = super.getErrorMessage(e, tokenNames);
            }
            return stack+" "+msg;
        }
        else {
            return super.getErrorMessage(e, tokenNames);
        }
    }
        
    public String getTokenErrorDisplay(Token t) {
        return DEBUG ? t.toString() : super.getTokenErrorDisplay(t);
    }



    public static class start_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "start"
    // VladNput/src/org/vladnput/VladParser.g:69:1: start : ( stmt )+ EOF ;
    public final VladParser.start_return start() throws RecognitionException {
        VladParser.start_return retval = new VladParser.start_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token EOF2=null;
        VladParser.stmt_return stmt1 = null;


        CommonTree EOF2_tree=null;

        try {
            // VladNput/src/org/vladnput/VladParser.g:70:2: ( ( stmt )+ EOF )
            // VladNput/src/org/vladnput/VladParser.g:70:4: ( stmt )+ EOF
            {
            root_0 = (CommonTree)adaptor.nil();

            // VladNput/src/org/vladnput/VladParser.g:70:4: ( stmt )+
            int cnt1=0;
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==INCLUDE||(LA1_0>=OPTIONS && LA1_0<=PARAM_MATCH)||(LA1_0>=TYPE && LA1_0<=URL_MATCH)) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladParser.g:70:4: stmt
            	    {
            	    pushFollow(FOLLOW_stmt_in_start96);
            	    stmt1=stmt();

            	    state._fsp--;

            	    adaptor.addChild(root_0, stmt1.getTree());

            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);

            EOF2=(Token)match(input,EOF,FOLLOW_EOF_in_start99); 
            EOF2_tree = (CommonTree)adaptor.create(EOF2);
            adaptor.addChild(root_0, EOF2_tree);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "start"

    public static class stmt_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "stmt"
    // VladNput/src/org/vladnput/VladParser.g:73:1: stmt : ( include_stmt SEMI | options_stmt | type_stmt SEMI | param_stmt SEMI | param_match_stmt SEMI | url_stmt | url_match_stmt );
    public final VladParser.stmt_return stmt() throws RecognitionException {
        VladParser.stmt_return retval = new VladParser.stmt_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token SEMI4=null;
        Token SEMI7=null;
        Token SEMI9=null;
        Token SEMI11=null;
        VladParser.include_stmt_return include_stmt3 = null;

        VladParser.options_stmt_return options_stmt5 = null;

        VladParser.type_stmt_return type_stmt6 = null;

        VladParser.param_stmt_return param_stmt8 = null;

        VladParser.param_match_stmt_return param_match_stmt10 = null;

        VladParser.url_stmt_return url_stmt12 = null;

        VladParser.url_match_stmt_return url_match_stmt13 = null;


        CommonTree SEMI4_tree=null;
        CommonTree SEMI7_tree=null;
        CommonTree SEMI9_tree=null;
        CommonTree SEMI11_tree=null;

        try {
            // VladNput/src/org/vladnput/VladParser.g:74:2: ( include_stmt SEMI | options_stmt | type_stmt SEMI | param_stmt SEMI | param_match_stmt SEMI | url_stmt | url_match_stmt )
            int alt2=7;
            switch ( input.LA(1) ) {
            case INCLUDE:
                {
                alt2=1;
                }
                break;
            case OPTIONS:
                {
                alt2=2;
                }
                break;
            case TYPE:
                {
                alt2=3;
                }
                break;
            case PARAM:
                {
                alt2=4;
                }
                break;
            case PARAM_MATCH:
                {
                alt2=5;
                }
                break;
            case URL:
                {
                alt2=6;
                }
                break;
            case URL_MATCH:
                {
                alt2=7;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:74:4: include_stmt SEMI
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_include_stmt_in_stmt110);
                    include_stmt3=include_stmt();

                    state._fsp--;

                    adaptor.addChild(root_0, include_stmt3.getTree());
                    SEMI4=(Token)match(input,SEMI,FOLLOW_SEMI_in_stmt112); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:75:4: options_stmt
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_options_stmt_in_stmt118);
                    options_stmt5=options_stmt();

                    state._fsp--;

                    adaptor.addChild(root_0, options_stmt5.getTree());

                    }
                    break;
                case 3 :
                    // VladNput/src/org/vladnput/VladParser.g:76:4: type_stmt SEMI
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_type_stmt_in_stmt123);
                    type_stmt6=type_stmt();

                    state._fsp--;

                    adaptor.addChild(root_0, type_stmt6.getTree());
                    SEMI7=(Token)match(input,SEMI,FOLLOW_SEMI_in_stmt125); 

                    }
                    break;
                case 4 :
                    // VladNput/src/org/vladnput/VladParser.g:77:4: param_stmt SEMI
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_param_stmt_in_stmt131);
                    param_stmt8=param_stmt();

                    state._fsp--;

                    adaptor.addChild(root_0, param_stmt8.getTree());
                    SEMI9=(Token)match(input,SEMI,FOLLOW_SEMI_in_stmt133); 

                    }
                    break;
                case 5 :
                    // VladNput/src/org/vladnput/VladParser.g:78:4: param_match_stmt SEMI
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_param_match_stmt_in_stmt139);
                    param_match_stmt10=param_match_stmt();

                    state._fsp--;

                    adaptor.addChild(root_0, param_match_stmt10.getTree());
                    SEMI11=(Token)match(input,SEMI,FOLLOW_SEMI_in_stmt141); 

                    }
                    break;
                case 6 :
                    // VladNput/src/org/vladnput/VladParser.g:79:4: url_stmt
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_url_stmt_in_stmt147);
                    url_stmt12=url_stmt();

                    state._fsp--;

                    adaptor.addChild(root_0, url_stmt12.getTree());

                    }
                    break;
                case 7 :
                    // VladNput/src/org/vladnput/VladParser.g:80:4: url_match_stmt
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_url_match_stmt_in_stmt152);
                    url_match_stmt13=url_match_stmt();

                    state._fsp--;

                    adaptor.addChild(root_0, url_match_stmt13.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "stmt"

    public static class include_stmt_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "include_stmt"
    // VladNput/src/org/vladnput/VladParser.g:83:1: include_stmt : INCLUDE include_file -> ^( INCLUDE include_file ) ;
    public final VladParser.include_stmt_return include_stmt() throws RecognitionException {
        VladParser.include_stmt_return retval = new VladParser.include_stmt_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token INCLUDE14=null;
        VladParser.include_file_return include_file15 = null;


        CommonTree INCLUDE14_tree=null;
        RewriteRuleTokenStream stream_INCLUDE=new RewriteRuleTokenStream(adaptor,"token INCLUDE");
        RewriteRuleSubtreeStream stream_include_file=new RewriteRuleSubtreeStream(adaptor,"rule include_file");
        try {
            // VladNput/src/org/vladnput/VladParser.g:84:2: ( INCLUDE include_file -> ^( INCLUDE include_file ) )
            // VladNput/src/org/vladnput/VladParser.g:84:4: INCLUDE include_file
            {
            INCLUDE14=(Token)match(input,INCLUDE,FOLLOW_INCLUDE_in_include_stmt163);  
            stream_INCLUDE.add(INCLUDE14);

            pushFollow(FOLLOW_include_file_in_include_stmt165);
            include_file15=include_file();

            state._fsp--;

            stream_include_file.add(include_file15.getTree());


            // AST REWRITE
            // elements: include_file, INCLUDE
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 85:3: -> ^( INCLUDE include_file )
            {
                // VladNput/src/org/vladnput/VladParser.g:85:6: ^( INCLUDE include_file )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_INCLUDE.nextNode(), root_1);

                adaptor.addChild(root_1, stream_include_file.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "include_stmt"

    public static class options_stmt_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "options_stmt"
    // VladNput/src/org/vladnput/VladParser.g:88:1: options_stmt : ( OPTIONS LBRACE ( option )+ RBRACE -> ^( OPTIONS ( option )+ ) | OPTIONS LBRACE RBRACE -> OPTIONS );
    public final VladParser.options_stmt_return options_stmt() throws RecognitionException {
        VladParser.options_stmt_return retval = new VladParser.options_stmt_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token OPTIONS16=null;
        Token LBRACE17=null;
        Token RBRACE19=null;
        Token OPTIONS20=null;
        Token LBRACE21=null;
        Token RBRACE22=null;
        VladParser.option_return option18 = null;


        CommonTree OPTIONS16_tree=null;
        CommonTree LBRACE17_tree=null;
        CommonTree RBRACE19_tree=null;
        CommonTree OPTIONS20_tree=null;
        CommonTree LBRACE21_tree=null;
        CommonTree RBRACE22_tree=null;
        RewriteRuleTokenStream stream_RBRACE=new RewriteRuleTokenStream(adaptor,"token RBRACE");
        RewriteRuleTokenStream stream_OPTIONS=new RewriteRuleTokenStream(adaptor,"token OPTIONS");
        RewriteRuleTokenStream stream_LBRACE=new RewriteRuleTokenStream(adaptor,"token LBRACE");
        RewriteRuleSubtreeStream stream_option=new RewriteRuleSubtreeStream(adaptor,"rule option");
        try {
            // VladNput/src/org/vladnput/VladParser.g:89:2: ( OPTIONS LBRACE ( option )+ RBRACE -> ^( OPTIONS ( option )+ ) | OPTIONS LBRACE RBRACE -> OPTIONS )
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==OPTIONS) ) {
                int LA4_1 = input.LA(2);

                if ( (LA4_1==LBRACE) ) {
                    int LA4_2 = input.LA(3);

                    if ( (LA4_2==RBRACE) ) {
                        alt4=2;
                    }
                    else if ( (LA4_2==MESSAGE_DEFAULTS||LA4_2==ID) ) {
                        alt4=1;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 4, 2, input);

                        throw nvae;
                    }
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 4, 1, input);

                    throw nvae;
                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }
            switch (alt4) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:89:4: OPTIONS LBRACE ( option )+ RBRACE
                    {
                    OPTIONS16=(Token)match(input,OPTIONS,FOLLOW_OPTIONS_in_options_stmt187);  
                    stream_OPTIONS.add(OPTIONS16);

                    LBRACE17=(Token)match(input,LBRACE,FOLLOW_LBRACE_in_options_stmt189);  
                    stream_LBRACE.add(LBRACE17);

                    // VladNput/src/org/vladnput/VladParser.g:89:19: ( option )+
                    int cnt3=0;
                    loop3:
                    do {
                        int alt3=2;
                        int LA3_0 = input.LA(1);

                        if ( (LA3_0==MESSAGE_DEFAULTS||LA3_0==ID) ) {
                            alt3=1;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // VladNput/src/org/vladnput/VladParser.g:89:19: option
                    	    {
                    	    pushFollow(FOLLOW_option_in_options_stmt191);
                    	    option18=option();

                    	    state._fsp--;

                    	    stream_option.add(option18.getTree());

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt3 >= 1 ) break loop3;
                                EarlyExitException eee =
                                    new EarlyExitException(3, input);
                                throw eee;
                        }
                        cnt3++;
                    } while (true);

                    RBRACE19=(Token)match(input,RBRACE,FOLLOW_RBRACE_in_options_stmt194);  
                    stream_RBRACE.add(RBRACE19);



                    // AST REWRITE
                    // elements: option, OPTIONS
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 90:3: -> ^( OPTIONS ( option )+ )
                    {
                        // VladNput/src/org/vladnput/VladParser.g:90:6: ^( OPTIONS ( option )+ )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_OPTIONS.nextNode(), root_1);

                        if ( !(stream_option.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_option.hasNext() ) {
                            adaptor.addChild(root_1, stream_option.nextTree());

                        }
                        stream_option.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;
                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:91:4: OPTIONS LBRACE RBRACE
                    {
                    OPTIONS20=(Token)match(input,OPTIONS,FOLLOW_OPTIONS_in_options_stmt210);  
                    stream_OPTIONS.add(OPTIONS20);

                    LBRACE21=(Token)match(input,LBRACE,FOLLOW_LBRACE_in_options_stmt212);  
                    stream_LBRACE.add(LBRACE21);

                    RBRACE22=(Token)match(input,RBRACE,FOLLOW_RBRACE_in_options_stmt214);  
                    stream_RBRACE.add(RBRACE22);



                    // AST REWRITE
                    // elements: OPTIONS
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 92:3: -> OPTIONS
                    {
                        adaptor.addChild(root_0, stream_OPTIONS.nextNode());

                    }

                    retval.tree = root_0;
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "options_stmt"

    public static class option_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "option"
    // VladNput/src/org/vladnput/VladParser.g:95:1: option : ( ID EQUALS literal SEMI -> ^( OPTION ID literal ) | msg_defaults SEMI -> msg_defaults );
    public final VladParser.option_return option() throws RecognitionException {
        VladParser.option_return retval = new VladParser.option_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ID23=null;
        Token EQUALS24=null;
        Token SEMI26=null;
        Token SEMI28=null;
        VladParser.literal_return literal25 = null;

        VladParser.msg_defaults_return msg_defaults27 = null;


        CommonTree ID23_tree=null;
        CommonTree EQUALS24_tree=null;
        CommonTree SEMI26_tree=null;
        CommonTree SEMI28_tree=null;
        RewriteRuleTokenStream stream_EQUALS=new RewriteRuleTokenStream(adaptor,"token EQUALS");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleTokenStream stream_SEMI=new RewriteRuleTokenStream(adaptor,"token SEMI");
        RewriteRuleSubtreeStream stream_msg_defaults=new RewriteRuleSubtreeStream(adaptor,"rule msg_defaults");
        RewriteRuleSubtreeStream stream_literal=new RewriteRuleSubtreeStream(adaptor,"rule literal");
        try {
            // VladNput/src/org/vladnput/VladParser.g:96:2: ( ID EQUALS literal SEMI -> ^( OPTION ID literal ) | msg_defaults SEMI -> msg_defaults )
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==ID) ) {
                alt5=1;
            }
            else if ( (LA5_0==MESSAGE_DEFAULTS) ) {
                alt5=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }
            switch (alt5) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:96:4: ID EQUALS literal SEMI
                    {
                    ID23=(Token)match(input,ID,FOLLOW_ID_in_option231);  
                    stream_ID.add(ID23);

                    EQUALS24=(Token)match(input,EQUALS,FOLLOW_EQUALS_in_option233);  
                    stream_EQUALS.add(EQUALS24);

                    pushFollow(FOLLOW_literal_in_option235);
                    literal25=literal();

                    state._fsp--;

                    stream_literal.add(literal25.getTree());
                    SEMI26=(Token)match(input,SEMI,FOLLOW_SEMI_in_option237);  
                    stream_SEMI.add(SEMI26);



                    // AST REWRITE
                    // elements: literal, ID
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 96:27: -> ^( OPTION ID literal )
                    {
                        // VladNput/src/org/vladnput/VladParser.g:96:30: ^( OPTION ID literal )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(OPTION, "OPTION"), root_1);

                        adaptor.addChild(root_1, stream_ID.nextNode());
                        adaptor.addChild(root_1, stream_literal.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;
                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:97:4: msg_defaults SEMI
                    {
                    pushFollow(FOLLOW_msg_defaults_in_option252);
                    msg_defaults27=msg_defaults();

                    state._fsp--;

                    stream_msg_defaults.add(msg_defaults27.getTree());
                    SEMI28=(Token)match(input,SEMI,FOLLOW_SEMI_in_option254);  
                    stream_SEMI.add(SEMI28);



                    // AST REWRITE
                    // elements: msg_defaults
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 97:22: -> msg_defaults
                    {
                        adaptor.addChild(root_0, stream_msg_defaults.nextTree());

                    }

                    retval.tree = root_0;
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "option"

    public static class type_stmt_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "type_stmt"
    // VladNput/src/org/vladnput/VladParser.g:100:1: type_stmt : TYPE ID EQUALS type_expr -> ^( TYPE ID type_expr ) ;
    public final VladParser.type_stmt_return type_stmt() throws RecognitionException {
        VladParser.type_stmt_return retval = new VladParser.type_stmt_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token TYPE29=null;
        Token ID30=null;
        Token EQUALS31=null;
        VladParser.type_expr_return type_expr32 = null;


        CommonTree TYPE29_tree=null;
        CommonTree ID30_tree=null;
        CommonTree EQUALS31_tree=null;
        RewriteRuleTokenStream stream_EQUALS=new RewriteRuleTokenStream(adaptor,"token EQUALS");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleTokenStream stream_TYPE=new RewriteRuleTokenStream(adaptor,"token TYPE");
        RewriteRuleSubtreeStream stream_type_expr=new RewriteRuleSubtreeStream(adaptor,"rule type_expr");
        try {
            // VladNput/src/org/vladnput/VladParser.g:101:2: ( TYPE ID EQUALS type_expr -> ^( TYPE ID type_expr ) )
            // VladNput/src/org/vladnput/VladParser.g:101:4: TYPE ID EQUALS type_expr
            {
            TYPE29=(Token)match(input,TYPE,FOLLOW_TYPE_in_type_stmt269);  
            stream_TYPE.add(TYPE29);

            ID30=(Token)match(input,ID,FOLLOW_ID_in_type_stmt271);  
            stream_ID.add(ID30);

            EQUALS31=(Token)match(input,EQUALS,FOLLOW_EQUALS_in_type_stmt273);  
            stream_EQUALS.add(EQUALS31);

            pushFollow(FOLLOW_type_expr_in_type_stmt275);
            type_expr32=type_expr();

            state._fsp--;

            stream_type_expr.add(type_expr32.getTree());


            // AST REWRITE
            // elements: TYPE, ID, type_expr
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 102:3: -> ^( TYPE ID type_expr )
            {
                // VladNput/src/org/vladnput/VladParser.g:102:6: ^( TYPE ID type_expr )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_TYPE.nextNode(), root_1);

                adaptor.addChild(root_1, stream_ID.nextNode());
                adaptor.addChild(root_1, stream_type_expr.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "type_stmt"

    public static class param_stmt_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "param_stmt"
    // VladNput/src/org/vladnput/VladParser.g:105:1: param_stmt : PARAM param_id card_spec param_args -> ^( PARAM param_id card_spec param_args ) ;
    public final VladParser.param_stmt_return param_stmt() throws RecognitionException {
        VladParser.param_stmt_return retval = new VladParser.param_stmt_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token PARAM33=null;
        VladParser.param_id_return param_id34 = null;

        VladParser.card_spec_return card_spec35 = null;

        VladParser.param_args_return param_args36 = null;


        CommonTree PARAM33_tree=null;
        RewriteRuleTokenStream stream_PARAM=new RewriteRuleTokenStream(adaptor,"token PARAM");
        RewriteRuleSubtreeStream stream_card_spec=new RewriteRuleSubtreeStream(adaptor,"rule card_spec");
        RewriteRuleSubtreeStream stream_param_id=new RewriteRuleSubtreeStream(adaptor,"rule param_id");
        RewriteRuleSubtreeStream stream_param_args=new RewriteRuleSubtreeStream(adaptor,"rule param_args");
        try {
            // VladNput/src/org/vladnput/VladParser.g:106:2: ( PARAM param_id card_spec param_args -> ^( PARAM param_id card_spec param_args ) )
            // VladNput/src/org/vladnput/VladParser.g:106:4: PARAM param_id card_spec param_args
            {
            PARAM33=(Token)match(input,PARAM,FOLLOW_PARAM_in_param_stmt299);  
            stream_PARAM.add(PARAM33);

            pushFollow(FOLLOW_param_id_in_param_stmt301);
            param_id34=param_id();

            state._fsp--;

            stream_param_id.add(param_id34.getTree());
            pushFollow(FOLLOW_card_spec_in_param_stmt303);
            card_spec35=card_spec();

            state._fsp--;

            stream_card_spec.add(card_spec35.getTree());
            pushFollow(FOLLOW_param_args_in_param_stmt305);
            param_args36=param_args();

            state._fsp--;

            stream_param_args.add(param_args36.getTree());


            // AST REWRITE
            // elements: param_id, param_args, PARAM, card_spec
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 107:3: -> ^( PARAM param_id card_spec param_args )
            {
                // VladNput/src/org/vladnput/VladParser.g:107:6: ^( PARAM param_id card_spec param_args )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_PARAM.nextNode(), root_1);

                adaptor.addChild(root_1, stream_param_id.nextTree());
                adaptor.addChild(root_1, stream_card_spec.nextTree());
                adaptor.addChild(root_1, stream_param_args.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "param_stmt"

    public static class param_id_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "param_id"
    // VladNput/src/org/vladnput/VladParser.g:110:1: param_id : ( ID | string );
    public final VladParser.param_id_return param_id() throws RecognitionException {
        VladParser.param_id_return retval = new VladParser.param_id_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ID37=null;
        VladParser.string_return string38 = null;


        CommonTree ID37_tree=null;

        try {
            // VladNput/src/org/vladnput/VladParser.g:111:2: ( ID | string )
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==ID) ) {
                alt6=1;
            }
            else if ( (LA6_0==SINGLEQUOTED_STRING||LA6_0==DOUBLEQUOTED_STRING) ) {
                alt6=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }
            switch (alt6) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:111:4: ID
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    ID37=(Token)match(input,ID,FOLLOW_ID_in_param_id331); 
                    ID37_tree = (CommonTree)adaptor.create(ID37);
                    adaptor.addChild(root_0, ID37_tree);


                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:112:4: string
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_string_in_param_id336);
                    string38=string();

                    state._fsp--;

                    adaptor.addChild(root_0, string38.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "param_id"

    public static class param_match_stmt_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "param_match_stmt"
    // VladNput/src/org/vladnput/VladParser.g:115:1: param_match_stmt : PARAM_MATCH string card_spec param_args -> ^( PARAM_MATCH string card_spec param_args ) ;
    public final VladParser.param_match_stmt_return param_match_stmt() throws RecognitionException {
        VladParser.param_match_stmt_return retval = new VladParser.param_match_stmt_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token PARAM_MATCH39=null;
        VladParser.string_return string40 = null;

        VladParser.card_spec_return card_spec41 = null;

        VladParser.param_args_return param_args42 = null;


        CommonTree PARAM_MATCH39_tree=null;
        RewriteRuleTokenStream stream_PARAM_MATCH=new RewriteRuleTokenStream(adaptor,"token PARAM_MATCH");
        RewriteRuleSubtreeStream stream_card_spec=new RewriteRuleSubtreeStream(adaptor,"rule card_spec");
        RewriteRuleSubtreeStream stream_param_args=new RewriteRuleSubtreeStream(adaptor,"rule param_args");
        RewriteRuleSubtreeStream stream_string=new RewriteRuleSubtreeStream(adaptor,"rule string");
        try {
            // VladNput/src/org/vladnput/VladParser.g:116:2: ( PARAM_MATCH string card_spec param_args -> ^( PARAM_MATCH string card_spec param_args ) )
            // VladNput/src/org/vladnput/VladParser.g:116:4: PARAM_MATCH string card_spec param_args
            {
            PARAM_MATCH39=(Token)match(input,PARAM_MATCH,FOLLOW_PARAM_MATCH_in_param_match_stmt348);  
            stream_PARAM_MATCH.add(PARAM_MATCH39);

            pushFollow(FOLLOW_string_in_param_match_stmt350);
            string40=string();

            state._fsp--;

            stream_string.add(string40.getTree());
            pushFollow(FOLLOW_card_spec_in_param_match_stmt352);
            card_spec41=card_spec();

            state._fsp--;

            stream_card_spec.add(card_spec41.getTree());
            pushFollow(FOLLOW_param_args_in_param_match_stmt354);
            param_args42=param_args();

            state._fsp--;

            stream_param_args.add(param_args42.getTree());


            // AST REWRITE
            // elements: param_args, PARAM_MATCH, string, card_spec
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 117:3: -> ^( PARAM_MATCH string card_spec param_args )
            {
                // VladNput/src/org/vladnput/VladParser.g:117:6: ^( PARAM_MATCH string card_spec param_args )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_PARAM_MATCH.nextNode(), root_1);

                adaptor.addChild(root_1, stream_string.nextTree());
                adaptor.addChild(root_1, stream_card_spec.nextTree());
                adaptor.addChild(root_1, stream_param_args.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "param_match_stmt"

    public static class url_stmt_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "url_stmt"
    // VladNput/src/org/vladnput/VladParser.g:120:1: url_stmt : URL url url_body -> ^( URL url url_body ) ;
    public final VladParser.url_stmt_return url_stmt() throws RecognitionException {
        VladParser.url_stmt_return retval = new VladParser.url_stmt_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token URL43=null;
        VladParser.url_return url44 = null;

        VladParser.url_body_return url_body45 = null;


        CommonTree URL43_tree=null;
        RewriteRuleTokenStream stream_URL=new RewriteRuleTokenStream(adaptor,"token URL");
        RewriteRuleSubtreeStream stream_url=new RewriteRuleSubtreeStream(adaptor,"rule url");
        RewriteRuleSubtreeStream stream_url_body=new RewriteRuleSubtreeStream(adaptor,"rule url_body");
        try {
            // VladNput/src/org/vladnput/VladParser.g:121:2: ( URL url url_body -> ^( URL url url_body ) )
            // VladNput/src/org/vladnput/VladParser.g:121:4: URL url url_body
            {
            URL43=(Token)match(input,URL,FOLLOW_URL_in_url_stmt379);  
            stream_URL.add(URL43);

            pushFollow(FOLLOW_url_in_url_stmt381);
            url44=url();

            state._fsp--;

            stream_url.add(url44.getTree());
            pushFollow(FOLLOW_url_body_in_url_stmt383);
            url_body45=url_body();

            state._fsp--;

            stream_url_body.add(url_body45.getTree());


            // AST REWRITE
            // elements: URL, url_body, url
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 122:3: -> ^( URL url url_body )
            {
                // VladNput/src/org/vladnput/VladParser.g:122:6: ^( URL url url_body )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_URL.nextNode(), root_1);

                adaptor.addChild(root_1, stream_url.nextTree());
                adaptor.addChild(root_1, stream_url_body.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "url_stmt"

    public static class url_match_stmt_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "url_match_stmt"
    // VladNput/src/org/vladnput/VladParser.g:125:1: url_match_stmt : URL_MATCH string url_body -> ^( URL_MATCH string url_body ) ;
    public final VladParser.url_match_stmt_return url_match_stmt() throws RecognitionException {
        VladParser.url_match_stmt_return retval = new VladParser.url_match_stmt_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token URL_MATCH46=null;
        VladParser.string_return string47 = null;

        VladParser.url_body_return url_body48 = null;


        CommonTree URL_MATCH46_tree=null;
        RewriteRuleTokenStream stream_URL_MATCH=new RewriteRuleTokenStream(adaptor,"token URL_MATCH");
        RewriteRuleSubtreeStream stream_string=new RewriteRuleSubtreeStream(adaptor,"rule string");
        RewriteRuleSubtreeStream stream_url_body=new RewriteRuleSubtreeStream(adaptor,"rule url_body");
        try {
            // VladNput/src/org/vladnput/VladParser.g:126:2: ( URL_MATCH string url_body -> ^( URL_MATCH string url_body ) )
            // VladNput/src/org/vladnput/VladParser.g:126:4: URL_MATCH string url_body
            {
            URL_MATCH46=(Token)match(input,URL_MATCH,FOLLOW_URL_MATCH_in_url_match_stmt406);  
            stream_URL_MATCH.add(URL_MATCH46);

            pushFollow(FOLLOW_string_in_url_match_stmt408);
            string47=string();

            state._fsp--;

            stream_string.add(string47.getTree());
            pushFollow(FOLLOW_url_body_in_url_match_stmt410);
            url_body48=url_body();

            state._fsp--;

            stream_url_body.add(url_body48.getTree());


            // AST REWRITE
            // elements: URL_MATCH, string, url_body
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 127:3: -> ^( URL_MATCH string url_body )
            {
                // VladNput/src/org/vladnput/VladParser.g:127:6: ^( URL_MATCH string url_body )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_URL_MATCH.nextNode(), root_1);

                adaptor.addChild(root_1, stream_string.nextTree());
                adaptor.addChild(root_1, stream_url_body.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "url_match_stmt"

    public static class url_body_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "url_body"
    // VladNput/src/org/vladnput/VladParser.g:130:1: url_body : ( LBRACE ( url_body_stmt )+ RBRACE -> ^( URL_BODY ( url_body_stmt )+ ) | LBRACE RBRACE -> NO_BODY );
    public final VladParser.url_body_return url_body() throws RecognitionException {
        VladParser.url_body_return retval = new VladParser.url_body_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LBRACE49=null;
        Token RBRACE51=null;
        Token LBRACE52=null;
        Token RBRACE53=null;
        VladParser.url_body_stmt_return url_body_stmt50 = null;


        CommonTree LBRACE49_tree=null;
        CommonTree RBRACE51_tree=null;
        CommonTree LBRACE52_tree=null;
        CommonTree RBRACE53_tree=null;
        RewriteRuleTokenStream stream_RBRACE=new RewriteRuleTokenStream(adaptor,"token RBRACE");
        RewriteRuleTokenStream stream_LBRACE=new RewriteRuleTokenStream(adaptor,"token LBRACE");
        RewriteRuleSubtreeStream stream_url_body_stmt=new RewriteRuleSubtreeStream(adaptor,"rule url_body_stmt");
        try {
            // VladNput/src/org/vladnput/VladParser.g:131:2: ( LBRACE ( url_body_stmt )+ RBRACE -> ^( URL_BODY ( url_body_stmt )+ ) | LBRACE RBRACE -> NO_BODY )
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==LBRACE) ) {
                int LA8_1 = input.LA(2);

                if ( (LA8_1==RBRACE) ) {
                    alt8=2;
                }
                else if ( ((LA8_1>=PARAM && LA8_1<=PARAM_MATCH)) ) {
                    alt8=1;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 8, 1, input);

                    throw nvae;
                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }
            switch (alt8) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:131:4: LBRACE ( url_body_stmt )+ RBRACE
                    {
                    LBRACE49=(Token)match(input,LBRACE,FOLLOW_LBRACE_in_url_body433);  
                    stream_LBRACE.add(LBRACE49);

                    // VladNput/src/org/vladnput/VladParser.g:131:11: ( url_body_stmt )+
                    int cnt7=0;
                    loop7:
                    do {
                        int alt7=2;
                        int LA7_0 = input.LA(1);

                        if ( ((LA7_0>=PARAM && LA7_0<=PARAM_MATCH)) ) {
                            alt7=1;
                        }


                        switch (alt7) {
                    	case 1 :
                    	    // VladNput/src/org/vladnput/VladParser.g:131:11: url_body_stmt
                    	    {
                    	    pushFollow(FOLLOW_url_body_stmt_in_url_body435);
                    	    url_body_stmt50=url_body_stmt();

                    	    state._fsp--;

                    	    stream_url_body_stmt.add(url_body_stmt50.getTree());

                    	    }
                    	    break;

                    	default :
                    	    if ( cnt7 >= 1 ) break loop7;
                                EarlyExitException eee =
                                    new EarlyExitException(7, input);
                                throw eee;
                        }
                        cnt7++;
                    } while (true);

                    RBRACE51=(Token)match(input,RBRACE,FOLLOW_RBRACE_in_url_body438);  
                    stream_RBRACE.add(RBRACE51);



                    // AST REWRITE
                    // elements: url_body_stmt
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 131:33: -> ^( URL_BODY ( url_body_stmt )+ )
                    {
                        // VladNput/src/org/vladnput/VladParser.g:131:36: ^( URL_BODY ( url_body_stmt )+ )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(URL_BODY, "URL_BODY"), root_1);

                        if ( !(stream_url_body_stmt.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_url_body_stmt.hasNext() ) {
                            adaptor.addChild(root_1, stream_url_body_stmt.nextTree());

                        }
                        stream_url_body_stmt.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;
                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:132:4: LBRACE RBRACE
                    {
                    LBRACE52=(Token)match(input,LBRACE,FOLLOW_LBRACE_in_url_body452);  
                    stream_LBRACE.add(LBRACE52);

                    RBRACE53=(Token)match(input,RBRACE,FOLLOW_RBRACE_in_url_body454);  
                    stream_RBRACE.add(RBRACE53);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 132:18: -> NO_BODY
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NO_BODY, "NO_BODY"));

                    }

                    retval.tree = root_0;
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "url_body"

    public static class url_body_stmt_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "url_body_stmt"
    // VladNput/src/org/vladnput/VladParser.g:135:1: url_body_stmt : ( param_stmt SEMI | param_match_stmt SEMI );
    public final VladParser.url_body_stmt_return url_body_stmt() throws RecognitionException {
        VladParser.url_body_stmt_return retval = new VladParser.url_body_stmt_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token SEMI55=null;
        Token SEMI57=null;
        VladParser.param_stmt_return param_stmt54 = null;

        VladParser.param_match_stmt_return param_match_stmt56 = null;


        CommonTree SEMI55_tree=null;
        CommonTree SEMI57_tree=null;

        try {
            // VladNput/src/org/vladnput/VladParser.g:136:2: ( param_stmt SEMI | param_match_stmt SEMI )
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==PARAM) ) {
                alt9=1;
            }
            else if ( (LA9_0==PARAM_MATCH) ) {
                alt9=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }
            switch (alt9) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:136:4: param_stmt SEMI
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_param_stmt_in_url_body_stmt470);
                    param_stmt54=param_stmt();

                    state._fsp--;

                    adaptor.addChild(root_0, param_stmt54.getTree());
                    SEMI55=(Token)match(input,SEMI,FOLLOW_SEMI_in_url_body_stmt472); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:137:4: param_match_stmt SEMI
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_param_match_stmt_in_url_body_stmt478);
                    param_match_stmt56=param_match_stmt();

                    state._fsp--;

                    adaptor.addChild(root_0, param_match_stmt56.getTree());
                    SEMI57=(Token)match(input,SEMI,FOLLOW_SEMI_in_url_body_stmt480); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "url_body_stmt"

    public static class include_file_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "include_file"
    // VladNput/src/org/vladnput/VladParser.g:140:1: include_file : ( string | ANGLE_STRING );
    public final VladParser.include_file_return include_file() throws RecognitionException {
        VladParser.include_file_return retval = new VladParser.include_file_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ANGLE_STRING59=null;
        VladParser.string_return string58 = null;


        CommonTree ANGLE_STRING59_tree=null;

        try {
            // VladNput/src/org/vladnput/VladParser.g:141:2: ( string | ANGLE_STRING )
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==SINGLEQUOTED_STRING||LA10_0==DOUBLEQUOTED_STRING) ) {
                alt10=1;
            }
            else if ( (LA10_0==ANGLE_STRING) ) {
                alt10=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 10, 0, input);

                throw nvae;
            }
            switch (alt10) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:141:4: string
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_string_in_include_file493);
                    string58=string();

                    state._fsp--;

                    adaptor.addChild(root_0, string58.getTree());

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:142:4: ANGLE_STRING
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    ANGLE_STRING59=(Token)match(input,ANGLE_STRING,FOLLOW_ANGLE_STRING_in_include_file498); 
                    ANGLE_STRING59_tree = (CommonTree)adaptor.create(ANGLE_STRING59);
                    adaptor.addChild(root_0, ANGLE_STRING59_tree);


                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "include_file"

    public static class url_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "url"
    // VladNput/src/org/vladnput/VladParser.g:145:1: url : ( URL_LITERAL | string );
    public final VladParser.url_return url() throws RecognitionException {
        VladParser.url_return retval = new VladParser.url_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token URL_LITERAL60=null;
        VladParser.string_return string61 = null;


        CommonTree URL_LITERAL60_tree=null;

        try {
            // VladNput/src/org/vladnput/VladParser.g:146:2: ( URL_LITERAL | string )
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==URL_LITERAL) ) {
                alt11=1;
            }
            else if ( (LA11_0==SINGLEQUOTED_STRING||LA11_0==DOUBLEQUOTED_STRING) ) {
                alt11=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 11, 0, input);

                throw nvae;
            }
            switch (alt11) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:146:4: URL_LITERAL
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    URL_LITERAL60=(Token)match(input,URL_LITERAL,FOLLOW_URL_LITERAL_in_url509); 
                    URL_LITERAL60_tree = (CommonTree)adaptor.create(URL_LITERAL60);
                    adaptor.addChild(root_0, URL_LITERAL60_tree);


                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:147:4: string
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_string_in_url514);
                    string61=string();

                    state._fsp--;

                    adaptor.addChild(root_0, string61.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "url"

    public static class card_spec_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "card_spec"
    // VladNput/src/org/vladnput/VladParser.g:150:1: card_spec : ( QUESTION | STAR | PLUS | CARET | LBRACE INT ( COMMA ( INT )? )? RBRACE -> ^( LBRACE ( INT )+ ) | -> NO_CARD_SPEC );
    public final VladParser.card_spec_return card_spec() throws RecognitionException {
        VladParser.card_spec_return retval = new VladParser.card_spec_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token QUESTION62=null;
        Token STAR63=null;
        Token PLUS64=null;
        Token CARET65=null;
        Token LBRACE66=null;
        Token INT67=null;
        Token COMMA68=null;
        Token INT69=null;
        Token RBRACE70=null;

        CommonTree QUESTION62_tree=null;
        CommonTree STAR63_tree=null;
        CommonTree PLUS64_tree=null;
        CommonTree CARET65_tree=null;
        CommonTree LBRACE66_tree=null;
        CommonTree INT67_tree=null;
        CommonTree COMMA68_tree=null;
        CommonTree INT69_tree=null;
        CommonTree RBRACE70_tree=null;
        RewriteRuleTokenStream stream_INT=new RewriteRuleTokenStream(adaptor,"token INT");
        RewriteRuleTokenStream stream_RBRACE=new RewriteRuleTokenStream(adaptor,"token RBRACE");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_LBRACE=new RewriteRuleTokenStream(adaptor,"token LBRACE");

        try {
            // VladNput/src/org/vladnput/VladParser.g:151:2: ( QUESTION | STAR | PLUS | CARET | LBRACE INT ( COMMA ( INT )? )? RBRACE -> ^( LBRACE ( INT )+ ) | -> NO_CARD_SPEC )
            int alt14=6;
            switch ( input.LA(1) ) {
            case QUESTION:
                {
                alt14=1;
                }
                break;
            case STAR:
                {
                alt14=2;
                }
                break;
            case PLUS:
                {
                alt14=3;
                }
                break;
            case CARET:
                {
                alt14=4;
                }
                break;
            case LBRACE:
                {
                alt14=5;
                }
                break;
            case SEMI:
            case LPAREN:
            case ID:
                {
                alt14=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 14, 0, input);

                throw nvae;
            }

            switch (alt14) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:151:4: QUESTION
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    QUESTION62=(Token)match(input,QUESTION,FOLLOW_QUESTION_in_card_spec525); 
                    QUESTION62_tree = (CommonTree)adaptor.create(QUESTION62);
                    adaptor.addChild(root_0, QUESTION62_tree);


                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:152:4: STAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    STAR63=(Token)match(input,STAR,FOLLOW_STAR_in_card_spec530); 
                    STAR63_tree = (CommonTree)adaptor.create(STAR63);
                    adaptor.addChild(root_0, STAR63_tree);


                    }
                    break;
                case 3 :
                    // VladNput/src/org/vladnput/VladParser.g:153:4: PLUS
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    PLUS64=(Token)match(input,PLUS,FOLLOW_PLUS_in_card_spec535); 
                    PLUS64_tree = (CommonTree)adaptor.create(PLUS64);
                    adaptor.addChild(root_0, PLUS64_tree);


                    }
                    break;
                case 4 :
                    // VladNput/src/org/vladnput/VladParser.g:154:4: CARET
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    CARET65=(Token)match(input,CARET,FOLLOW_CARET_in_card_spec540); 
                    CARET65_tree = (CommonTree)adaptor.create(CARET65);
                    adaptor.addChild(root_0, CARET65_tree);


                    }
                    break;
                case 5 :
                    // VladNput/src/org/vladnput/VladParser.g:155:4: LBRACE INT ( COMMA ( INT )? )? RBRACE
                    {
                    LBRACE66=(Token)match(input,LBRACE,FOLLOW_LBRACE_in_card_spec545);  
                    stream_LBRACE.add(LBRACE66);

                    INT67=(Token)match(input,INT,FOLLOW_INT_in_card_spec547);  
                    stream_INT.add(INT67);

                    // VladNput/src/org/vladnput/VladParser.g:155:15: ( COMMA ( INT )? )?
                    int alt13=2;
                    int LA13_0 = input.LA(1);

                    if ( (LA13_0==COMMA) ) {
                        alt13=1;
                    }
                    switch (alt13) {
                        case 1 :
                            // VladNput/src/org/vladnput/VladParser.g:155:17: COMMA ( INT )?
                            {
                            COMMA68=(Token)match(input,COMMA,FOLLOW_COMMA_in_card_spec551);  
                            stream_COMMA.add(COMMA68);

                            // VladNput/src/org/vladnput/VladParser.g:155:23: ( INT )?
                            int alt12=2;
                            int LA12_0 = input.LA(1);

                            if ( (LA12_0==INT) ) {
                                alt12=1;
                            }
                            switch (alt12) {
                                case 1 :
                                    // VladNput/src/org/vladnput/VladParser.g:155:23: INT
                                    {
                                    INT69=(Token)match(input,INT,FOLLOW_INT_in_card_spec553);  
                                    stream_INT.add(INT69);


                                    }
                                    break;

                            }


                            }
                            break;

                    }

                    RBRACE70=(Token)match(input,RBRACE,FOLLOW_RBRACE_in_card_spec559);  
                    stream_RBRACE.add(RBRACE70);



                    // AST REWRITE
                    // elements: INT, LBRACE
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 155:38: -> ^( LBRACE ( INT )+ )
                    {
                        // VladNput/src/org/vladnput/VladParser.g:155:41: ^( LBRACE ( INT )+ )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_LBRACE.nextNode(), root_1);

                        if ( !(stream_INT.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_INT.hasNext() ) {
                            adaptor.addChild(root_1, stream_INT.nextNode());

                        }
                        stream_INT.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;
                    }
                    break;
                case 6 :
                    // VladNput/src/org/vladnput/VladParser.g:156:4: 
                    {

                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 156:4: -> NO_CARD_SPEC
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NO_CARD_SPEC, "NO_CARD_SPEC"));

                    }

                    retval.tree = root_0;
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "card_spec"

    public static class param_args_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "param_args"
    // VladNput/src/org/vladnput/VladParser.g:159:1: param_args : ( type_expr | param_kw_args | -> NO_ARGS );
    public final VladParser.param_args_return param_args() throws RecognitionException {
        VladParser.param_args_return retval = new VladParser.param_args_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        VladParser.type_expr_return type_expr71 = null;

        VladParser.param_kw_args_return param_kw_args72 = null;



        try {
            // VladNput/src/org/vladnput/VladParser.g:160:2: ( type_expr | param_kw_args | -> NO_ARGS )
            int alt15=3;
            switch ( input.LA(1) ) {
            case ID:
                {
                alt15=1;
                }
                break;
            case LPAREN:
                {
                alt15=2;
                }
                break;
            case SEMI:
                {
                alt15=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 15, 0, input);

                throw nvae;
            }

            switch (alt15) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:160:4: type_expr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_type_expr_in_param_args587);
                    type_expr71=type_expr();

                    state._fsp--;

                    adaptor.addChild(root_0, type_expr71.getTree());

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:161:4: param_kw_args
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_param_kw_args_in_param_args592);
                    param_kw_args72=param_kw_args();

                    state._fsp--;

                    adaptor.addChild(root_0, param_kw_args72.getTree());

                    }
                    break;
                case 3 :
                    // VladNput/src/org/vladnput/VladParser.g:162:4: 
                    {

                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 162:4: -> NO_ARGS
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(NO_ARGS, "NO_ARGS"));

                    }

                    retval.tree = root_0;
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "param_args"

    public static class type_expr_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "type_expr"
    // VladNput/src/org/vladnput/VladParser.g:165:1: type_expr : qname ( type_kw_args )? ;
    public final VladParser.type_expr_return type_expr() throws RecognitionException {
        VladParser.type_expr_return retval = new VladParser.type_expr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        VladParser.qname_return qname73 = null;

        VladParser.type_kw_args_return type_kw_args74 = null;



        try {
            // VladNput/src/org/vladnput/VladParser.g:166:2: ( qname ( type_kw_args )? )
            // VladNput/src/org/vladnput/VladParser.g:166:4: qname ( type_kw_args )?
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_qname_in_type_expr612);
            qname73=qname();

            state._fsp--;

            adaptor.addChild(root_0, qname73.getTree());
            // VladNput/src/org/vladnput/VladParser.g:166:10: ( type_kw_args )?
            int alt16=2;
            int LA16_0 = input.LA(1);

            if ( (LA16_0==LPAREN) ) {
                alt16=1;
            }
            switch (alt16) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:166:10: type_kw_args
                    {
                    pushFollow(FOLLOW_type_kw_args_in_type_expr614);
                    type_kw_args74=type_kw_args();

                    state._fsp--;

                    adaptor.addChild(root_0, type_kw_args74.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "type_expr"

    public static class msg_defaults_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "msg_defaults"
    // VladNput/src/org/vladnput/VladParser.g:169:1: msg_defaults : MESSAGE_DEFAULTS LPAREN msg_defaults_kw_args RPAREN -> ^( MESSAGE_DEFAULTS msg_defaults_kw_args ) ;
    public final VladParser.msg_defaults_return msg_defaults() throws RecognitionException {
        VladParser.msg_defaults_return retval = new VladParser.msg_defaults_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token MESSAGE_DEFAULTS75=null;
        Token LPAREN76=null;
        Token RPAREN78=null;
        VladParser.msg_defaults_kw_args_return msg_defaults_kw_args77 = null;


        CommonTree MESSAGE_DEFAULTS75_tree=null;
        CommonTree LPAREN76_tree=null;
        CommonTree RPAREN78_tree=null;
        RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
        RewriteRuleTokenStream stream_MESSAGE_DEFAULTS=new RewriteRuleTokenStream(adaptor,"token MESSAGE_DEFAULTS");
        RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
        RewriteRuleSubtreeStream stream_msg_defaults_kw_args=new RewriteRuleSubtreeStream(adaptor,"rule msg_defaults_kw_args");
        try {
            // VladNput/src/org/vladnput/VladParser.g:170:2: ( MESSAGE_DEFAULTS LPAREN msg_defaults_kw_args RPAREN -> ^( MESSAGE_DEFAULTS msg_defaults_kw_args ) )
            // VladNput/src/org/vladnput/VladParser.g:170:4: MESSAGE_DEFAULTS LPAREN msg_defaults_kw_args RPAREN
            {
            MESSAGE_DEFAULTS75=(Token)match(input,MESSAGE_DEFAULTS,FOLLOW_MESSAGE_DEFAULTS_in_msg_defaults626);  
            stream_MESSAGE_DEFAULTS.add(MESSAGE_DEFAULTS75);

            LPAREN76=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_msg_defaults628);  
            stream_LPAREN.add(LPAREN76);

            pushFollow(FOLLOW_msg_defaults_kw_args_in_msg_defaults630);
            msg_defaults_kw_args77=msg_defaults_kw_args();

            state._fsp--;

            stream_msg_defaults_kw_args.add(msg_defaults_kw_args77.getTree());
            RPAREN78=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_msg_defaults632);  
            stream_RPAREN.add(RPAREN78);



            // AST REWRITE
            // elements: msg_defaults_kw_args, MESSAGE_DEFAULTS
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 171:3: -> ^( MESSAGE_DEFAULTS msg_defaults_kw_args )
            {
                // VladNput/src/org/vladnput/VladParser.g:171:6: ^( MESSAGE_DEFAULTS msg_defaults_kw_args )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_MESSAGE_DEFAULTS.nextNode(), root_1);

                adaptor.addChild(root_1, stream_msg_defaults_kw_args.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "msg_defaults"

    public static class msg_defaults_kw_args_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "msg_defaults_kw_args"
    // VladNput/src/org/vladnput/VladParser.g:174:1: msg_defaults_kw_args : msg_defaults_kw_arg ( COMMA msg_defaults_kw_arg )* -> ^( KW_ARGS ( msg_defaults_kw_arg )+ ) ;
    public final VladParser.msg_defaults_kw_args_return msg_defaults_kw_args() throws RecognitionException {
        VladParser.msg_defaults_kw_args_return retval = new VladParser.msg_defaults_kw_args_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA80=null;
        VladParser.msg_defaults_kw_arg_return msg_defaults_kw_arg79 = null;

        VladParser.msg_defaults_kw_arg_return msg_defaults_kw_arg81 = null;


        CommonTree COMMA80_tree=null;
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleSubtreeStream stream_msg_defaults_kw_arg=new RewriteRuleSubtreeStream(adaptor,"rule msg_defaults_kw_arg");
        try {
            // VladNput/src/org/vladnput/VladParser.g:175:2: ( msg_defaults_kw_arg ( COMMA msg_defaults_kw_arg )* -> ^( KW_ARGS ( msg_defaults_kw_arg )+ ) )
            // VladNput/src/org/vladnput/VladParser.g:175:4: msg_defaults_kw_arg ( COMMA msg_defaults_kw_arg )*
            {
            pushFollow(FOLLOW_msg_defaults_kw_arg_in_msg_defaults_kw_args653);
            msg_defaults_kw_arg79=msg_defaults_kw_arg();

            state._fsp--;

            stream_msg_defaults_kw_arg.add(msg_defaults_kw_arg79.getTree());
            // VladNput/src/org/vladnput/VladParser.g:175:24: ( COMMA msg_defaults_kw_arg )*
            loop17:
            do {
                int alt17=2;
                int LA17_0 = input.LA(1);

                if ( (LA17_0==COMMA) ) {
                    alt17=1;
                }


                switch (alt17) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladParser.g:175:26: COMMA msg_defaults_kw_arg
            	    {
            	    COMMA80=(Token)match(input,COMMA,FOLLOW_COMMA_in_msg_defaults_kw_args657);  
            	    stream_COMMA.add(COMMA80);

            	    pushFollow(FOLLOW_msg_defaults_kw_arg_in_msg_defaults_kw_args659);
            	    msg_defaults_kw_arg81=msg_defaults_kw_arg();

            	    state._fsp--;

            	    stream_msg_defaults_kw_arg.add(msg_defaults_kw_arg81.getTree());

            	    }
            	    break;

            	default :
            	    break loop17;
                }
            } while (true);



            // AST REWRITE
            // elements: msg_defaults_kw_arg
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 176:3: -> ^( KW_ARGS ( msg_defaults_kw_arg )+ )
            {
                // VladNput/src/org/vladnput/VladParser.g:176:6: ^( KW_ARGS ( msg_defaults_kw_arg )+ )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(KW_ARGS, "KW_ARGS"), root_1);

                if ( !(stream_msg_defaults_kw_arg.hasNext()) ) {
                    throw new RewriteEarlyExitException();
                }
                while ( stream_msg_defaults_kw_arg.hasNext() ) {
                    adaptor.addChild(root_1, stream_msg_defaults_kw_arg.nextTree());

                }
                stream_msg_defaults_kw_arg.reset();

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "msg_defaults_kw_args"

    public static class msg_defaults_kw_arg_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "msg_defaults_kw_arg"
    // VladNput/src/org/vladnput/VladParser.g:179:1: msg_defaults_kw_arg : ID EQUALS string -> ^( ID string ) ;
    public final VladParser.msg_defaults_kw_arg_return msg_defaults_kw_arg() throws RecognitionException {
        VladParser.msg_defaults_kw_arg_return retval = new VladParser.msg_defaults_kw_arg_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ID82=null;
        Token EQUALS83=null;
        VladParser.string_return string84 = null;


        CommonTree ID82_tree=null;
        CommonTree EQUALS83_tree=null;
        RewriteRuleTokenStream stream_EQUALS=new RewriteRuleTokenStream(adaptor,"token EQUALS");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleSubtreeStream stream_string=new RewriteRuleSubtreeStream(adaptor,"rule string");
        try {
            // VladNput/src/org/vladnput/VladParser.g:180:2: ( ID EQUALS string -> ^( ID string ) )
            // VladNput/src/org/vladnput/VladParser.g:180:4: ID EQUALS string
            {
            ID82=(Token)match(input,ID,FOLLOW_ID_in_msg_defaults_kw_arg684);  
            stream_ID.add(ID82);

            EQUALS83=(Token)match(input,EQUALS,FOLLOW_EQUALS_in_msg_defaults_kw_arg686);  
            stream_EQUALS.add(EQUALS83);

            pushFollow(FOLLOW_string_in_msg_defaults_kw_arg688);
            string84=string();

            state._fsp--;

            stream_string.add(string84.getTree());


            // AST REWRITE
            // elements: ID, string
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 180:21: -> ^( ID string )
            {
                // VladNput/src/org/vladnput/VladParser.g:180:24: ^( ID string )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_ID.nextNode(), root_1);

                adaptor.addChild(root_1, stream_string.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "msg_defaults_kw_arg"

    public static class param_kw_args_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "param_kw_args"
    // VladNput/src/org/vladnput/VladParser.g:183:1: param_kw_args : ( LPAREN param_kw_arg ( COMMA param_kw_arg )* RPAREN -> ^( KW_ARGS ( param_kw_arg )+ ) | LPAREN RPAREN -> EMPTY_ARGS );
    public final VladParser.param_kw_args_return param_kw_args() throws RecognitionException {
        VladParser.param_kw_args_return retval = new VladParser.param_kw_args_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LPAREN85=null;
        Token COMMA87=null;
        Token RPAREN89=null;
        Token LPAREN90=null;
        Token RPAREN91=null;
        VladParser.param_kw_arg_return param_kw_arg86 = null;

        VladParser.param_kw_arg_return param_kw_arg88 = null;


        CommonTree LPAREN85_tree=null;
        CommonTree COMMA87_tree=null;
        CommonTree RPAREN89_tree=null;
        CommonTree LPAREN90_tree=null;
        CommonTree RPAREN91_tree=null;
        RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
        RewriteRuleSubtreeStream stream_param_kw_arg=new RewriteRuleSubtreeStream(adaptor,"rule param_kw_arg");
        try {
            // VladNput/src/org/vladnput/VladParser.g:184:2: ( LPAREN param_kw_arg ( COMMA param_kw_arg )* RPAREN -> ^( KW_ARGS ( param_kw_arg )+ ) | LPAREN RPAREN -> EMPTY_ARGS )
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==LPAREN) ) {
                int LA19_1 = input.LA(2);

                if ( (LA19_1==RPAREN) ) {
                    alt19=2;
                }
                else if ( (LA19_1==TYPE||LA19_1==ID) ) {
                    alt19=1;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 19, 1, input);

                    throw nvae;
                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 19, 0, input);

                throw nvae;
            }
            switch (alt19) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:184:4: LPAREN param_kw_arg ( COMMA param_kw_arg )* RPAREN
                    {
                    LPAREN85=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_param_kw_args707);  
                    stream_LPAREN.add(LPAREN85);

                    pushFollow(FOLLOW_param_kw_arg_in_param_kw_args709);
                    param_kw_arg86=param_kw_arg();

                    state._fsp--;

                    stream_param_kw_arg.add(param_kw_arg86.getTree());
                    // VladNput/src/org/vladnput/VladParser.g:184:24: ( COMMA param_kw_arg )*
                    loop18:
                    do {
                        int alt18=2;
                        int LA18_0 = input.LA(1);

                        if ( (LA18_0==COMMA) ) {
                            alt18=1;
                        }


                        switch (alt18) {
                    	case 1 :
                    	    // VladNput/src/org/vladnput/VladParser.g:184:26: COMMA param_kw_arg
                    	    {
                    	    COMMA87=(Token)match(input,COMMA,FOLLOW_COMMA_in_param_kw_args713);  
                    	    stream_COMMA.add(COMMA87);

                    	    pushFollow(FOLLOW_param_kw_arg_in_param_kw_args715);
                    	    param_kw_arg88=param_kw_arg();

                    	    state._fsp--;

                    	    stream_param_kw_arg.add(param_kw_arg88.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop18;
                        }
                    } while (true);

                    RPAREN89=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_param_kw_args720);  
                    stream_RPAREN.add(RPAREN89);



                    // AST REWRITE
                    // elements: param_kw_arg
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 184:55: -> ^( KW_ARGS ( param_kw_arg )+ )
                    {
                        // VladNput/src/org/vladnput/VladParser.g:184:58: ^( KW_ARGS ( param_kw_arg )+ )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(KW_ARGS, "KW_ARGS"), root_1);

                        if ( !(stream_param_kw_arg.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_param_kw_arg.hasNext() ) {
                            adaptor.addChild(root_1, stream_param_kw_arg.nextTree());

                        }
                        stream_param_kw_arg.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;
                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:185:4: LPAREN RPAREN
                    {
                    LPAREN90=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_param_kw_args734);  
                    stream_LPAREN.add(LPAREN90);

                    RPAREN91=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_param_kw_args736);  
                    stream_RPAREN.add(RPAREN91);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 185:18: -> EMPTY_ARGS
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(EMPTY_ARGS, "EMPTY_ARGS"));

                    }

                    retval.tree = root_0;
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "param_kw_args"

    public static class param_kw_arg_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "param_kw_arg"
    // VladNput/src/org/vladnput/VladParser.g:188:1: param_kw_arg : ( TYPE EQUALS type_expr -> ^( TYPE type_expr ) | ID EQUALS literal -> ^( ID literal ) );
    public final VladParser.param_kw_arg_return param_kw_arg() throws RecognitionException {
        VladParser.param_kw_arg_return retval = new VladParser.param_kw_arg_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token TYPE92=null;
        Token EQUALS93=null;
        Token ID95=null;
        Token EQUALS96=null;
        VladParser.type_expr_return type_expr94 = null;

        VladParser.literal_return literal97 = null;


        CommonTree TYPE92_tree=null;
        CommonTree EQUALS93_tree=null;
        CommonTree ID95_tree=null;
        CommonTree EQUALS96_tree=null;
        RewriteRuleTokenStream stream_EQUALS=new RewriteRuleTokenStream(adaptor,"token EQUALS");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleTokenStream stream_TYPE=new RewriteRuleTokenStream(adaptor,"token TYPE");
        RewriteRuleSubtreeStream stream_type_expr=new RewriteRuleSubtreeStream(adaptor,"rule type_expr");
        RewriteRuleSubtreeStream stream_literal=new RewriteRuleSubtreeStream(adaptor,"rule literal");
        try {
            // VladNput/src/org/vladnput/VladParser.g:189:2: ( TYPE EQUALS type_expr -> ^( TYPE type_expr ) | ID EQUALS literal -> ^( ID literal ) )
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==TYPE) ) {
                alt20=1;
            }
            else if ( (LA20_0==ID) ) {
                alt20=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 20, 0, input);

                throw nvae;
            }
            switch (alt20) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:189:4: TYPE EQUALS type_expr
                    {
                    TYPE92=(Token)match(input,TYPE,FOLLOW_TYPE_in_param_kw_arg751);  
                    stream_TYPE.add(TYPE92);

                    EQUALS93=(Token)match(input,EQUALS,FOLLOW_EQUALS_in_param_kw_arg753);  
                    stream_EQUALS.add(EQUALS93);

                    pushFollow(FOLLOW_type_expr_in_param_kw_arg755);
                    type_expr94=type_expr();

                    state._fsp--;

                    stream_type_expr.add(type_expr94.getTree());


                    // AST REWRITE
                    // elements: TYPE, type_expr
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 189:26: -> ^( TYPE type_expr )
                    {
                        // VladNput/src/org/vladnput/VladParser.g:189:29: ^( TYPE type_expr )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_TYPE.nextNode(), root_1);

                        adaptor.addChild(root_1, stream_type_expr.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;
                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:190:4: ID EQUALS literal
                    {
                    ID95=(Token)match(input,ID,FOLLOW_ID_in_param_kw_arg768);  
                    stream_ID.add(ID95);

                    EQUALS96=(Token)match(input,EQUALS,FOLLOW_EQUALS_in_param_kw_arg770);  
                    stream_EQUALS.add(EQUALS96);

                    pushFollow(FOLLOW_literal_in_param_kw_arg772);
                    literal97=literal();

                    state._fsp--;

                    stream_literal.add(literal97.getTree());


                    // AST REWRITE
                    // elements: literal, ID
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 190:22: -> ^( ID literal )
                    {
                        // VladNput/src/org/vladnput/VladParser.g:190:25: ^( ID literal )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot(stream_ID.nextNode(), root_1);

                        adaptor.addChild(root_1, stream_literal.nextTree());

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "param_kw_arg"

    public static class type_kw_args_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "type_kw_args"
    // VladNput/src/org/vladnput/VladParser.g:193:1: type_kw_args : ( LPAREN type_kw_arg ( COMMA type_kw_arg )* RPAREN -> ^( KW_ARGS ( type_kw_arg )+ ) | LPAREN RPAREN -> EMPTY_ARGS );
    public final VladParser.type_kw_args_return type_kw_args() throws RecognitionException {
        VladParser.type_kw_args_return retval = new VladParser.type_kw_args_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LPAREN98=null;
        Token COMMA100=null;
        Token RPAREN102=null;
        Token LPAREN103=null;
        Token RPAREN104=null;
        VladParser.type_kw_arg_return type_kw_arg99 = null;

        VladParser.type_kw_arg_return type_kw_arg101 = null;


        CommonTree LPAREN98_tree=null;
        CommonTree COMMA100_tree=null;
        CommonTree RPAREN102_tree=null;
        CommonTree LPAREN103_tree=null;
        CommonTree RPAREN104_tree=null;
        RewriteRuleTokenStream stream_RPAREN=new RewriteRuleTokenStream(adaptor,"token RPAREN");
        RewriteRuleTokenStream stream_COMMA=new RewriteRuleTokenStream(adaptor,"token COMMA");
        RewriteRuleTokenStream stream_LPAREN=new RewriteRuleTokenStream(adaptor,"token LPAREN");
        RewriteRuleSubtreeStream stream_type_kw_arg=new RewriteRuleSubtreeStream(adaptor,"rule type_kw_arg");
        try {
            // VladNput/src/org/vladnput/VladParser.g:194:2: ( LPAREN type_kw_arg ( COMMA type_kw_arg )* RPAREN -> ^( KW_ARGS ( type_kw_arg )+ ) | LPAREN RPAREN -> EMPTY_ARGS )
            int alt22=2;
            int LA22_0 = input.LA(1);

            if ( (LA22_0==LPAREN) ) {
                int LA22_1 = input.LA(2);

                if ( (LA22_1==RPAREN) ) {
                    alt22=2;
                }
                else if ( (LA22_1==ID) ) {
                    alt22=1;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 22, 1, input);

                    throw nvae;
                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 22, 0, input);

                throw nvae;
            }
            switch (alt22) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:194:4: LPAREN type_kw_arg ( COMMA type_kw_arg )* RPAREN
                    {
                    LPAREN98=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_type_kw_args791);  
                    stream_LPAREN.add(LPAREN98);

                    pushFollow(FOLLOW_type_kw_arg_in_type_kw_args793);
                    type_kw_arg99=type_kw_arg();

                    state._fsp--;

                    stream_type_kw_arg.add(type_kw_arg99.getTree());
                    // VladNput/src/org/vladnput/VladParser.g:194:23: ( COMMA type_kw_arg )*
                    loop21:
                    do {
                        int alt21=2;
                        int LA21_0 = input.LA(1);

                        if ( (LA21_0==COMMA) ) {
                            alt21=1;
                        }


                        switch (alt21) {
                    	case 1 :
                    	    // VladNput/src/org/vladnput/VladParser.g:194:25: COMMA type_kw_arg
                    	    {
                    	    COMMA100=(Token)match(input,COMMA,FOLLOW_COMMA_in_type_kw_args797);  
                    	    stream_COMMA.add(COMMA100);

                    	    pushFollow(FOLLOW_type_kw_arg_in_type_kw_args799);
                    	    type_kw_arg101=type_kw_arg();

                    	    state._fsp--;

                    	    stream_type_kw_arg.add(type_kw_arg101.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop21;
                        }
                    } while (true);

                    RPAREN102=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_type_kw_args804);  
                    stream_RPAREN.add(RPAREN102);



                    // AST REWRITE
                    // elements: type_kw_arg
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 194:53: -> ^( KW_ARGS ( type_kw_arg )+ )
                    {
                        // VladNput/src/org/vladnput/VladParser.g:194:56: ^( KW_ARGS ( type_kw_arg )+ )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(KW_ARGS, "KW_ARGS"), root_1);

                        if ( !(stream_type_kw_arg.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_type_kw_arg.hasNext() ) {
                            adaptor.addChild(root_1, stream_type_kw_arg.nextTree());

                        }
                        stream_type_kw_arg.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;
                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:195:4: LPAREN RPAREN
                    {
                    LPAREN103=(Token)match(input,LPAREN,FOLLOW_LPAREN_in_type_kw_args818);  
                    stream_LPAREN.add(LPAREN103);

                    RPAREN104=(Token)match(input,RPAREN,FOLLOW_RPAREN_in_type_kw_args820);  
                    stream_RPAREN.add(RPAREN104);



                    // AST REWRITE
                    // elements: 
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 195:18: -> EMPTY_ARGS
                    {
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(EMPTY_ARGS, "EMPTY_ARGS"));

                    }

                    retval.tree = root_0;
                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "type_kw_args"

    public static class type_kw_arg_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "type_kw_arg"
    // VladNput/src/org/vladnput/VladParser.g:198:1: type_kw_arg : ID EQUALS literal -> ^( ID literal ) ;
    public final VladParser.type_kw_arg_return type_kw_arg() throws RecognitionException {
        VladParser.type_kw_arg_return retval = new VladParser.type_kw_arg_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ID105=null;
        Token EQUALS106=null;
        VladParser.literal_return literal107 = null;


        CommonTree ID105_tree=null;
        CommonTree EQUALS106_tree=null;
        RewriteRuleTokenStream stream_EQUALS=new RewriteRuleTokenStream(adaptor,"token EQUALS");
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleSubtreeStream stream_literal=new RewriteRuleSubtreeStream(adaptor,"rule literal");
        try {
            // VladNput/src/org/vladnput/VladParser.g:199:2: ( ID EQUALS literal -> ^( ID literal ) )
            // VladNput/src/org/vladnput/VladParser.g:199:4: ID EQUALS literal
            {
            ID105=(Token)match(input,ID,FOLLOW_ID_in_type_kw_arg835);  
            stream_ID.add(ID105);

            EQUALS106=(Token)match(input,EQUALS,FOLLOW_EQUALS_in_type_kw_arg837);  
            stream_EQUALS.add(EQUALS106);

            pushFollow(FOLLOW_literal_in_type_kw_arg839);
            literal107=literal();

            state._fsp--;

            stream_literal.add(literal107.getTree());


            // AST REWRITE
            // elements: ID, literal
            // token labels: 
            // rule labels: retval
            // token list labels: 
            // rule list labels: 
            // wildcard labels: 
            retval.tree = root_0;
            RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

            root_0 = (CommonTree)adaptor.nil();
            // 199:22: -> ^( ID literal )
            {
                // VladNput/src/org/vladnput/VladParser.g:199:25: ^( ID literal )
                {
                CommonTree root_1 = (CommonTree)adaptor.nil();
                root_1 = (CommonTree)adaptor.becomeRoot(stream_ID.nextNode(), root_1);

                adaptor.addChild(root_1, stream_literal.nextTree());

                adaptor.addChild(root_0, root_1);
                }

            }

            retval.tree = root_0;
            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "type_kw_arg"

    public static class qname_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "qname"
    // VladNput/src/org/vladnput/VladParser.g:202:1: qname : ( ID ( DOT ID )+ -> ^( QNAME ( ID )+ ) | ID );
    public final VladParser.qname_return qname() throws RecognitionException {
        VladParser.qname_return retval = new VladParser.qname_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ID108=null;
        Token DOT109=null;
        Token ID110=null;
        Token ID111=null;

        CommonTree ID108_tree=null;
        CommonTree DOT109_tree=null;
        CommonTree ID110_tree=null;
        CommonTree ID111_tree=null;
        RewriteRuleTokenStream stream_ID=new RewriteRuleTokenStream(adaptor,"token ID");
        RewriteRuleTokenStream stream_DOT=new RewriteRuleTokenStream(adaptor,"token DOT");

        try {
            // VladNput/src/org/vladnput/VladParser.g:203:2: ( ID ( DOT ID )+ -> ^( QNAME ( ID )+ ) | ID )
            int alt24=2;
            int LA24_0 = input.LA(1);

            if ( (LA24_0==ID) ) {
                int LA24_1 = input.LA(2);

                if ( (LA24_1==COMMA||(LA24_1>=SEMI && LA24_1<=LPAREN)) ) {
                    alt24=2;
                }
                else if ( (LA24_1==DOT) ) {
                    alt24=1;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 24, 1, input);

                    throw nvae;
                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 24, 0, input);

                throw nvae;
            }
            switch (alt24) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:203:4: ID ( DOT ID )+
                    {
                    ID108=(Token)match(input,ID,FOLLOW_ID_in_qname858);  
                    stream_ID.add(ID108);

                    // VladNput/src/org/vladnput/VladParser.g:203:7: ( DOT ID )+
                    int cnt23=0;
                    loop23:
                    do {
                        int alt23=2;
                        int LA23_0 = input.LA(1);

                        if ( (LA23_0==DOT) ) {
                            alt23=1;
                        }


                        switch (alt23) {
                    	case 1 :
                    	    // VladNput/src/org/vladnput/VladParser.g:203:9: DOT ID
                    	    {
                    	    DOT109=(Token)match(input,DOT,FOLLOW_DOT_in_qname862);  
                    	    stream_DOT.add(DOT109);

                    	    ID110=(Token)match(input,ID,FOLLOW_ID_in_qname864);  
                    	    stream_ID.add(ID110);


                    	    }
                    	    break;

                    	default :
                    	    if ( cnt23 >= 1 ) break loop23;
                                EarlyExitException eee =
                                    new EarlyExitException(23, input);
                                throw eee;
                        }
                        cnt23++;
                    } while (true);



                    // AST REWRITE
                    // elements: ID
                    // token labels: 
                    // rule labels: retval
                    // token list labels: 
                    // rule list labels: 
                    // wildcard labels: 
                    retval.tree = root_0;
                    RewriteRuleSubtreeStream stream_retval=new RewriteRuleSubtreeStream(adaptor,"rule retval",retval!=null?retval.tree:null);

                    root_0 = (CommonTree)adaptor.nil();
                    // 203:19: -> ^( QNAME ( ID )+ )
                    {
                        // VladNput/src/org/vladnput/VladParser.g:203:22: ^( QNAME ( ID )+ )
                        {
                        CommonTree root_1 = (CommonTree)adaptor.nil();
                        root_1 = (CommonTree)adaptor.becomeRoot((CommonTree)adaptor.create(QNAME, "QNAME"), root_1);

                        if ( !(stream_ID.hasNext()) ) {
                            throw new RewriteEarlyExitException();
                        }
                        while ( stream_ID.hasNext() ) {
                            adaptor.addChild(root_1, stream_ID.nextNode());

                        }
                        stream_ID.reset();

                        adaptor.addChild(root_0, root_1);
                        }

                    }

                    retval.tree = root_0;
                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:204:4: ID
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    ID111=(Token)match(input,ID,FOLLOW_ID_in_qname881); 
                    ID111_tree = (CommonTree)adaptor.create(ID111);
                    adaptor.addChild(root_0, ID111_tree);


                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "qname"

    public static class literal_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "literal"
    // VladNput/src/org/vladnput/VladParser.g:207:1: literal : ( string | INT | FLOAT | TRUE | FALSE );
    public final VladParser.literal_return literal() throws RecognitionException {
        VladParser.literal_return retval = new VladParser.literal_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token INT113=null;
        Token FLOAT114=null;
        Token TRUE115=null;
        Token FALSE116=null;
        VladParser.string_return string112 = null;


        CommonTree INT113_tree=null;
        CommonTree FLOAT114_tree=null;
        CommonTree TRUE115_tree=null;
        CommonTree FALSE116_tree=null;

        try {
            // VladNput/src/org/vladnput/VladParser.g:208:2: ( string | INT | FLOAT | TRUE | FALSE )
            int alt25=5;
            switch ( input.LA(1) ) {
            case SINGLEQUOTED_STRING:
            case DOUBLEQUOTED_STRING:
                {
                alt25=1;
                }
                break;
            case INT:
                {
                alt25=2;
                }
                break;
            case FLOAT:
                {
                alt25=3;
                }
                break;
            case TRUE:
                {
                alt25=4;
                }
                break;
            case FALSE:
                {
                alt25=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }

            switch (alt25) {
                case 1 :
                    // VladNput/src/org/vladnput/VladParser.g:208:4: string
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_string_in_literal893);
                    string112=string();

                    state._fsp--;

                    adaptor.addChild(root_0, string112.getTree());

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladParser.g:209:4: INT
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    INT113=(Token)match(input,INT,FOLLOW_INT_in_literal898); 
                    INT113_tree = (CommonTree)adaptor.create(INT113);
                    adaptor.addChild(root_0, INT113_tree);


                    }
                    break;
                case 3 :
                    // VladNput/src/org/vladnput/VladParser.g:210:4: FLOAT
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FLOAT114=(Token)match(input,FLOAT,FOLLOW_FLOAT_in_literal903); 
                    FLOAT114_tree = (CommonTree)adaptor.create(FLOAT114);
                    adaptor.addChild(root_0, FLOAT114_tree);


                    }
                    break;
                case 4 :
                    // VladNput/src/org/vladnput/VladParser.g:211:4: TRUE
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    TRUE115=(Token)match(input,TRUE,FOLLOW_TRUE_in_literal908); 
                    TRUE115_tree = (CommonTree)adaptor.create(TRUE115);
                    adaptor.addChild(root_0, TRUE115_tree);


                    }
                    break;
                case 5 :
                    // VladNput/src/org/vladnput/VladParser.g:212:4: FALSE
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FALSE116=(Token)match(input,FALSE,FOLLOW_FALSE_in_literal913); 
                    FALSE116_tree = (CommonTree)adaptor.create(FALSE116);
                    adaptor.addChild(root_0, FALSE116_tree);


                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "literal"

    public static class string_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "string"
    // VladNput/src/org/vladnput/VladParser.g:215:1: string : ( DOUBLEQUOTED_STRING | SINGLEQUOTED_STRING );
    public final VladParser.string_return string() throws RecognitionException {
        VladParser.string_return retval = new VladParser.string_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set117=null;

        CommonTree set117_tree=null;

        try {
            // VladNput/src/org/vladnput/VladParser.g:216:2: ( DOUBLEQUOTED_STRING | SINGLEQUOTED_STRING )
            // VladNput/src/org/vladnput/VladParser.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            set117=(Token)input.LT(1);
            if ( input.LA(1)==SINGLEQUOTED_STRING||input.LA(1)==DOUBLEQUOTED_STRING ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(set117));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (CommonTree)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "string"

    // Delegated rules


 

    public static final BitSet FOLLOW_stmt_in_start96 = new BitSet(new long[]{0x0000000000003BA0L});
    public static final BitSet FOLLOW_EOF_in_start99 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_include_stmt_in_stmt110 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_SEMI_in_stmt112 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_options_stmt_in_stmt118 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_stmt_in_stmt123 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_SEMI_in_stmt125 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_param_stmt_in_stmt131 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_SEMI_in_stmt133 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_param_match_stmt_in_stmt139 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_SEMI_in_stmt141 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_url_stmt_in_stmt147 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_url_match_stmt_in_stmt152 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INCLUDE_in_include_stmt163 = new BitSet(new long[]{0x0000000068000000L});
    public static final BitSet FOLLOW_include_file_in_include_stmt165 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OPTIONS_in_options_stmt187 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_LBRACE_in_options_stmt189 = new BitSet(new long[]{0x0000000080000040L});
    public static final BitSet FOLLOW_option_in_options_stmt191 = new BitSet(new long[]{0x0000000081000040L});
    public static final BitSet FOLLOW_RBRACE_in_options_stmt194 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OPTIONS_in_options_stmt210 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_LBRACE_in_options_stmt212 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_RBRACE_in_options_stmt214 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_option231 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_EQUALS_in_option233 = new BitSet(new long[]{0x0000000328000410L});
    public static final BitSet FOLLOW_literal_in_option235 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_SEMI_in_option237 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_msg_defaults_in_option252 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_SEMI_in_option254 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TYPE_in_type_stmt269 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_ID_in_type_stmt271 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_EQUALS_in_type_stmt273 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_type_expr_in_type_stmt275 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PARAM_in_param_stmt299 = new BitSet(new long[]{0x00000000A8000000L});
    public static final BitSet FOLLOW_param_id_in_param_stmt301 = new BitSet(new long[]{0x0000000082F40000L});
    public static final BitSet FOLLOW_card_spec_in_param_stmt303 = new BitSet(new long[]{0x0000000080040000L});
    public static final BitSet FOLLOW_param_args_in_param_stmt305 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_param_id331 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_string_in_param_id336 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PARAM_MATCH_in_param_match_stmt348 = new BitSet(new long[]{0x0000000028000000L});
    public static final BitSet FOLLOW_string_in_param_match_stmt350 = new BitSet(new long[]{0x0000000082F40000L});
    public static final BitSet FOLLOW_card_spec_in_param_match_stmt352 = new BitSet(new long[]{0x0000000080040000L});
    public static final BitSet FOLLOW_param_args_in_param_match_stmt354 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_URL_in_url_stmt379 = new BitSet(new long[]{0x000000002C000000L});
    public static final BitSet FOLLOW_url_in_url_stmt381 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_url_body_in_url_stmt383 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_URL_MATCH_in_url_match_stmt406 = new BitSet(new long[]{0x0000000028000000L});
    public static final BitSet FOLLOW_string_in_url_match_stmt408 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_url_body_in_url_match_stmt410 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LBRACE_in_url_body433 = new BitSet(new long[]{0x0000000000000300L});
    public static final BitSet FOLLOW_url_body_stmt_in_url_body435 = new BitSet(new long[]{0x0000000001000300L});
    public static final BitSet FOLLOW_RBRACE_in_url_body438 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LBRACE_in_url_body452 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_RBRACE_in_url_body454 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_param_stmt_in_url_body_stmt470 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_SEMI_in_url_body_stmt472 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_param_match_stmt_in_url_body_stmt478 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_SEMI_in_url_body_stmt480 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_string_in_include_file493 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ANGLE_STRING_in_include_file498 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_URL_LITERAL_in_url509 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_string_in_url514 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QUESTION_in_card_spec525 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_card_spec530 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_card_spec535 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CARET_in_card_spec540 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LBRACE_in_card_spec545 = new BitSet(new long[]{0x0000000200000000L});
    public static final BitSet FOLLOW_INT_in_card_spec547 = new BitSet(new long[]{0x0000000001004000L});
    public static final BitSet FOLLOW_COMMA_in_card_spec551 = new BitSet(new long[]{0x0000000201000000L});
    public static final BitSet FOLLOW_INT_in_card_spec553 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_RBRACE_in_card_spec559 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_expr_in_param_args587 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_param_kw_args_in_param_args592 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qname_in_type_expr612 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_type_kw_args_in_type_expr614 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MESSAGE_DEFAULTS_in_msg_defaults626 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_LPAREN_in_msg_defaults628 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_msg_defaults_kw_args_in_msg_defaults630 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_RPAREN_in_msg_defaults632 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_msg_defaults_kw_arg_in_msg_defaults_kw_args653 = new BitSet(new long[]{0x0000000000004002L});
    public static final BitSet FOLLOW_COMMA_in_msg_defaults_kw_args657 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_msg_defaults_kw_arg_in_msg_defaults_kw_args659 = new BitSet(new long[]{0x0000000000004002L});
    public static final BitSet FOLLOW_ID_in_msg_defaults_kw_arg684 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_EQUALS_in_msg_defaults_kw_arg686 = new BitSet(new long[]{0x0000000028000000L});
    public static final BitSet FOLLOW_string_in_msg_defaults_kw_arg688 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_param_kw_args707 = new BitSet(new long[]{0x0000000080000800L});
    public static final BitSet FOLLOW_param_kw_arg_in_param_kw_args709 = new BitSet(new long[]{0x0000000000024000L});
    public static final BitSet FOLLOW_COMMA_in_param_kw_args713 = new BitSet(new long[]{0x0000000080000800L});
    public static final BitSet FOLLOW_param_kw_arg_in_param_kw_args715 = new BitSet(new long[]{0x0000000000024000L});
    public static final BitSet FOLLOW_RPAREN_in_param_kw_args720 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_param_kw_args734 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_RPAREN_in_param_kw_args736 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TYPE_in_param_kw_arg751 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_EQUALS_in_param_kw_arg753 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_type_expr_in_param_kw_arg755 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_param_kw_arg768 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_EQUALS_in_param_kw_arg770 = new BitSet(new long[]{0x0000000328000410L});
    public static final BitSet FOLLOW_literal_in_param_kw_arg772 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_type_kw_args791 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_type_kw_arg_in_type_kw_args793 = new BitSet(new long[]{0x0000000000024000L});
    public static final BitSet FOLLOW_COMMA_in_type_kw_args797 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_type_kw_arg_in_type_kw_args799 = new BitSet(new long[]{0x0000000000024000L});
    public static final BitSet FOLLOW_RPAREN_in_type_kw_args804 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_type_kw_args818 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_RPAREN_in_type_kw_args820 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_type_kw_arg835 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_EQUALS_in_type_kw_arg837 = new BitSet(new long[]{0x0000000328000410L});
    public static final BitSet FOLLOW_literal_in_type_kw_arg839 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_qname858 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_DOT_in_qname862 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_ID_in_qname864 = new BitSet(new long[]{0x0000000000008002L});
    public static final BitSet FOLLOW_ID_in_qname881 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_string_in_literal893 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_literal898 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FLOAT_in_literal903 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRUE_in_literal908 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_literal913 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_string0 = new BitSet(new long[]{0x0000000000000002L});

}