/* Copyright 2009 Patrick Higgins 
 *
 * This file is part of VladNput.
 *
 * VladNput is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * VladNput is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with VladNput.  If not, see <http://www.gnu.org/licenses/>.
 */
// $ANTLR 3.1.3 Mar 17, 2009 19:23:44 VladNput/src/org/vladnput/VladWalker.g 2009-10-23 16:08:42

package org.vladnput;

import java.util.Map;
import java.util.LinkedHashMap;
import java.util.regex.Pattern;


import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class VladWalker extends VladTreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "FALSE", "INCLUDE", "MESSAGE_DEFAULTS", "OPTIONS", "PARAM", "PARAM_MATCH", "TRUE", "TYPE", "URL", "URL_MATCH", "COMMA", "DOT", "SEMI", "RPAREN", "LPAREN", "EQUALS", "QUESTION", "STAR", "PLUS", "LBRACE", "RBRACE", "CARET", "URL_LITERAL", "SINGLEQUOTED_STRING", "EscapeSequence", "DOUBLEQUOTED_STRING", "ANGLE_STRING", "ID", "FLOAT", "INT", "WS", "SL_COMMENT", "ML_COMMENT", "EMPTY_ARGS", "KW_ARGS", "NO_ARGS", "NO_BODY", "NO_CARD_SPEC", "OPTION", "QNAME", "URL_BODY"
    };
    public static final int URL_BODY=44;
    public static final int STAR=21;
    public static final int OPTION=42;
    public static final int EMPTY_ARGS=37;
    public static final int PARAM_MATCH=9;
    public static final int LBRACE=23;
    public static final int NO_CARD_SPEC=41;
    public static final int PARAM=8;
    public static final int FLOAT=32;
    public static final int EQUALS=19;
    public static final int ID=31;
    public static final int EOF=-1;
    public static final int LPAREN=18;
    public static final int TYPE=11;
    public static final int ML_COMMENT=36;
    public static final int RPAREN=17;
    public static final int NO_BODY=40;
    public static final int COMMA=14;
    public static final int CARET=25;
    public static final int INCLUDE=5;
    public static final int PLUS=22;
    public static final int DOT=15;
    public static final int URL_LITERAL=26;
    public static final int NO_ARGS=39;
    public static final int RBRACE=24;
    public static final int DOUBLEQUOTED_STRING=29;
    public static final int INT=33;
    public static final int KW_ARGS=38;
    public static final int SEMI=16;
    public static final int TRUE=10;
    public static final int URL=12;
    public static final int WS=34;
    public static final int QNAME=43;
    public static final int QUESTION=20;
    public static final int URL_MATCH=13;
    public static final int ANGLE_STRING=30;
    public static final int SL_COMMENT=35;
    public static final int MESSAGE_DEFAULTS=6;
    public static final int FALSE=4;
    public static final int EscapeSequence=28;
    public static final int SINGLEQUOTED_STRING=27;
    public static final int OPTIONS=7;

    // delegates
    // delegators


        public VladWalker(TreeNodeStream input) {
            this(input, new RecognizerSharedState());
        }
        public VladWalker(TreeNodeStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return VladWalker.tokenNames; }
    public String getGrammarFileName() { return "VladNput/src/org/vladnput/VladWalker.g"; }



    private final static boolean DEBUG = false;

    public void setParseErrors(ParseErrors parseErrors) {
        setErrors(parseErrors);
    }

    public String getErrorHeader(RecognitionException e) {
        return VladUtil.getSourceLocation(e);
    }

    public void emitErrorMessage(String msg) {
        getErrors().add(msg);
    }

    public String getErrorMessage(RecognitionException e, String[] tokenNames) {
        if (DEBUG) {
            List stack = getRuleInvocationStack(e, this.getClass().getName());
            String msg = null;
            if (e instanceof NoViableAltException) {
                NoViableAltException nvae = (NoViableAltException) e;
                msg = " no viable alt; token="+e.token+
                      " (decision="+nvae.decisionNumber+
                      " state "+nvae.stateNumber+")"+
                      " decision=<<"+nvae.grammarDecisionDescription+">>";
            }
            else {
                msg = super.getErrorMessage(e, tokenNames);
            }
            return stack+" "+msg;
        }
        else {
            return super.getErrorMessage(e, tokenNames);
        }
    }
        
    public String getTokenErrorDisplay(Token t) {
        return DEBUG ? t.toString() : super.getTokenErrorDisplay(t);
    }




    // $ANTLR start "start"
    // VladNput/src/org/vladnput/VladWalker.g:60:1: start : ( stmt )+ EOF ;
    public final void start() throws RecognitionException {
        try {
            // VladNput/src/org/vladnput/VladWalker.g:61:2: ( ( stmt )+ EOF )
            // VladNput/src/org/vladnput/VladWalker.g:61:4: ( stmt )+ EOF
            {
            // VladNput/src/org/vladnput/VladWalker.g:61:4: ( stmt )+
            int cnt1=0;
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==INCLUDE||(LA1_0>=OPTIONS && LA1_0<=PARAM_MATCH)||(LA1_0>=TYPE && LA1_0<=URL_MATCH)) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladWalker.g:61:4: stmt
            	    {
            	    pushFollow(FOLLOW_stmt_in_start51);
            	    stmt();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);

            match(input,EOF,FOLLOW_EOF_in_start54); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "start"


    // $ANTLR start "stmt"
    // VladNput/src/org/vladnput/VladWalker.g:64:1: stmt : ( include_stmt | options_stmt | type_stmt | param_stmt | param_match_stmt | url_stmt | url_match_stmt );
    public final void stmt() throws RecognitionException {
        try {
            // VladNput/src/org/vladnput/VladWalker.g:65:2: ( include_stmt | options_stmt | type_stmt | param_stmt | param_match_stmt | url_stmt | url_match_stmt )
            int alt2=7;
            switch ( input.LA(1) ) {
            case INCLUDE:
                {
                alt2=1;
                }
                break;
            case OPTIONS:
                {
                alt2=2;
                }
                break;
            case TYPE:
                {
                alt2=3;
                }
                break;
            case PARAM:
                {
                alt2=4;
                }
                break;
            case PARAM_MATCH:
                {
                alt2=5;
                }
                break;
            case URL:
                {
                alt2=6;
                }
                break;
            case URL_MATCH:
                {
                alt2=7;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:65:4: include_stmt
                    {
                    pushFollow(FOLLOW_include_stmt_in_stmt65);
                    include_stmt();

                    state._fsp--;


                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:66:4: options_stmt
                    {
                    pushFollow(FOLLOW_options_stmt_in_stmt70);
                    options_stmt();

                    state._fsp--;


                    }
                    break;
                case 3 :
                    // VladNput/src/org/vladnput/VladWalker.g:67:4: type_stmt
                    {
                    pushFollow(FOLLOW_type_stmt_in_stmt75);
                    type_stmt();

                    state._fsp--;


                    }
                    break;
                case 4 :
                    // VladNput/src/org/vladnput/VladWalker.g:68:4: param_stmt
                    {
                    pushFollow(FOLLOW_param_stmt_in_stmt80);
                    param_stmt();

                    state._fsp--;


                    }
                    break;
                case 5 :
                    // VladNput/src/org/vladnput/VladWalker.g:69:4: param_match_stmt
                    {
                    pushFollow(FOLLOW_param_match_stmt_in_stmt85);
                    param_match_stmt();

                    state._fsp--;


                    }
                    break;
                case 6 :
                    // VladNput/src/org/vladnput/VladWalker.g:70:4: url_stmt
                    {
                    pushFollow(FOLLOW_url_stmt_in_stmt90);
                    url_stmt();

                    state._fsp--;


                    }
                    break;
                case 7 :
                    // VladNput/src/org/vladnput/VladWalker.g:71:4: url_match_stmt
                    {
                    pushFollow(FOLLOW_url_match_stmt_in_stmt95);
                    url_match_stmt();

                    state._fsp--;


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "stmt"


    // $ANTLR start "include_stmt"
    // VladNput/src/org/vladnput/VladWalker.g:74:1: include_stmt : ^( INCLUDE ( string | ANGLE_STRING ) ) ;
    public final void include_stmt() throws RecognitionException {
        CommonTree ANGLE_STRING2=null;
        VladWalker.string_return string1 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:75:2: ( ^( INCLUDE ( string | ANGLE_STRING ) ) )
            // VladNput/src/org/vladnput/VladWalker.g:75:4: ^( INCLUDE ( string | ANGLE_STRING ) )
            {
            match(input,INCLUDE,FOLLOW_INCLUDE_in_include_stmt107); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                // VladNput/src/org/vladnput/VladWalker.g:76:5: ( string | ANGLE_STRING )
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0==UP||(LA3_0>=QUESTION && LA3_0<=LBRACE)||LA3_0==CARET||LA3_0==SINGLEQUOTED_STRING||LA3_0==DOUBLEQUOTED_STRING||(LA3_0>=NO_BODY && LA3_0<=NO_CARD_SPEC)||LA3_0==URL_BODY) ) {
                    alt3=1;
                }
                else if ( (LA3_0==ANGLE_STRING) ) {
                    alt3=2;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 3, 0, input);

                    throw nvae;
                }
                switch (alt3) {
                    case 1 :
                        // VladNput/src/org/vladnput/VladWalker.g:76:7: string
                        {
                        pushFollow(FOLLOW_string_in_include_stmt115);
                        string1=string();

                        state._fsp--;

                         includeFile((string1!=null?string1.value:null), (string1!=null?string1.tree:null)); 

                        }
                        break;
                    case 2 :
                        // VladNput/src/org/vladnput/VladWalker.g:77:7: ANGLE_STRING
                        {
                        ANGLE_STRING2=(CommonTree)match(input,ANGLE_STRING,FOLLOW_ANGLE_STRING_in_include_stmt126); 
                         includeResource(ANGLE_STRING2); 

                        }
                        break;

                }


                match(input, Token.UP, null); 
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "include_stmt"


    // $ANTLR start "options_stmt"
    // VladNput/src/org/vladnput/VladWalker.g:82:1: options_stmt : ( ^( OPTIONS ( option )+ ) | OPTIONS );
    public final void options_stmt() throws RecognitionException {
        try {
            // VladNput/src/org/vladnput/VladWalker.g:83:2: ( ^( OPTIONS ( option )+ ) | OPTIONS )
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==OPTIONS) ) {
                int LA5_1 = input.LA(2);

                if ( (LA5_1==DOWN) ) {
                    alt5=1;
                }
                else if ( (LA5_1==EOF||LA5_1==INCLUDE||(LA5_1>=OPTIONS && LA5_1<=PARAM_MATCH)||(LA5_1>=TYPE && LA5_1<=URL_MATCH)) ) {
                    alt5=2;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 5, 1, input);

                    throw nvae;
                }
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }
            switch (alt5) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:83:4: ^( OPTIONS ( option )+ )
                    {
                    match(input,OPTIONS,FOLLOW_OPTIONS_in_options_stmt165); 

                    match(input, Token.DOWN, null); 
                    // VladNput/src/org/vladnput/VladWalker.g:83:14: ( option )+
                    int cnt4=0;
                    loop4:
                    do {
                        int alt4=2;
                        int LA4_0 = input.LA(1);

                        if ( (LA4_0==MESSAGE_DEFAULTS||LA4_0==OPTION) ) {
                            alt4=1;
                        }


                        switch (alt4) {
                    	case 1 :
                    	    // VladNput/src/org/vladnput/VladWalker.g:83:14: option
                    	    {
                    	    pushFollow(FOLLOW_option_in_options_stmt167);
                    	    option();

                    	    state._fsp--;


                    	    }
                    	    break;

                    	default :
                    	    if ( cnt4 >= 1 ) break loop4;
                                EarlyExitException eee =
                                    new EarlyExitException(4, input);
                                throw eee;
                        }
                        cnt4++;
                    } while (true);


                    match(input, Token.UP, null); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:84:4: OPTIONS
                    {
                    match(input,OPTIONS,FOLLOW_OPTIONS_in_options_stmt174); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "options_stmt"


    // $ANTLR start "option"
    // VladNput/src/org/vladnput/VladWalker.g:87:1: option : ( ^( OPTION ID literal ) | msg_defaults );
    public final void option() throws RecognitionException {
        CommonTree ID3=null;
        VladWalker.literal_return literal4 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:88:2: ( ^( OPTION ID literal ) | msg_defaults )
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==OPTION) ) {
                alt6=1;
            }
            else if ( (LA6_0==MESSAGE_DEFAULTS) ) {
                alt6=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }
            switch (alt6) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:88:4: ^( OPTION ID literal )
                    {
                    match(input,OPTION,FOLLOW_OPTION_in_option187); 

                    match(input, Token.DOWN, null); 
                    ID3=(CommonTree)match(input,ID,FOLLOW_ID_in_option189); 
                    pushFollow(FOLLOW_literal_in_option191);
                    literal4=literal();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     addOption(ID3, (literal4!=null?literal4.value:null), (literal4!=null?literal4.tree:null)); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:89:4: msg_defaults
                    {
                    pushFollow(FOLLOW_msg_defaults_in_option199);
                    msg_defaults();

                    state._fsp--;


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "option"


    // $ANTLR start "type_stmt"
    // VladNput/src/org/vladnput/VladWalker.g:92:1: type_stmt : ^( TYPE ID type_expr ) ;
    public final void type_stmt() throws RecognitionException {
        CommonTree ID5=null;
        Type type_expr6 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:93:2: ( ^( TYPE ID type_expr ) )
            // VladNput/src/org/vladnput/VladWalker.g:93:4: ^( TYPE ID type_expr )
            {
            match(input,TYPE,FOLLOW_TYPE_in_type_stmt211); 

            match(input, Token.DOWN, null); 
            ID5=(CommonTree)match(input,ID,FOLLOW_ID_in_type_stmt213); 
            pushFollow(FOLLOW_type_expr_in_type_stmt215);
            type_expr6=type_expr();

            state._fsp--;


            match(input, Token.UP, null); 
             defineType(ID5, type_expr6); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "type_stmt"


    // $ANTLR start "param_stmt"
    // VladNput/src/org/vladnput/VladWalker.g:96:1: param_stmt : ^( PARAM param_id card_spec param_args ) ;
    public final void param_stmt() throws RecognitionException {
        try {
            // VladNput/src/org/vladnput/VladWalker.g:98:2: ( ^( PARAM param_id card_spec param_args ) )
            // VladNput/src/org/vladnput/VladWalker.g:98:4: ^( PARAM param_id card_spec param_args )
            {
            match(input,PARAM,FOLLOW_PARAM_in_param_stmt236); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                pushFollow(FOLLOW_param_id_in_param_stmt242);
                param_id();

                state._fsp--;

                pushFollow(FOLLOW_card_spec_in_param_stmt248);
                card_spec();

                state._fsp--;

                pushFollow(FOLLOW_param_args_in_param_stmt254);
                param_args();

                state._fsp--;


                match(input, Token.UP, null); 
            }

            }

             finishParam((Param) currentParam); currentParam = null; 
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "param_stmt"


    // $ANTLR start "param_id"
    // VladNput/src/org/vladnput/VladWalker.g:105:1: param_id : ( ID | string );
    public final void param_id() throws RecognitionException {
        CommonTree ID7=null;
        VladWalker.string_return string8 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:106:2: ( ID | string )
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==ID) ) {
                alt7=1;
            }
            else if ( (LA7_0==UP||(LA7_0>=QUESTION && LA7_0<=LBRACE)||LA7_0==CARET||LA7_0==SINGLEQUOTED_STRING||LA7_0==DOUBLEQUOTED_STRING||(LA7_0>=NO_BODY && LA7_0<=NO_CARD_SPEC)||LA7_0==URL_BODY) ) {
                alt7=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }
            switch (alt7) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:106:4: ID
                    {
                    ID7=(CommonTree)match(input,ID,FOLLOW_ID_in_param_id271); 
                     currentParam = addParam((ID7!=null?ID7.getText():null), ID7); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:107:4: string
                    {
                    pushFollow(FOLLOW_string_in_param_id279);
                    string8=string();

                    state._fsp--;

                     currentParam = addParam((string8!=null?string8.value:null), (string8!=null?string8.tree:null)); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "param_id"


    // $ANTLR start "param_match_stmt"
    // VladNput/src/org/vladnput/VladWalker.g:110:1: param_match_stmt : ^( PARAM_MATCH regex card_spec param_args ) ;
    public final void param_match_stmt() throws RecognitionException {
        VladWalker.regex_return regex9 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:112:2: ( ^( PARAM_MATCH regex card_spec param_args ) )
            // VladNput/src/org/vladnput/VladWalker.g:112:4: ^( PARAM_MATCH regex card_spec param_args )
            {
            match(input,PARAM_MATCH,FOLLOW_PARAM_MATCH_in_param_match_stmt299); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                pushFollow(FOLLOW_regex_in_param_match_stmt305);
                regex9=regex();

                state._fsp--;

                 currentParam = addParamMatch((regex9!=null?regex9.value:null), (regex9!=null?regex9.tree:null)); 
                pushFollow(FOLLOW_card_spec_in_param_match_stmt314);
                card_spec();

                state._fsp--;

                pushFollow(FOLLOW_param_args_in_param_match_stmt320);
                param_args();

                state._fsp--;


                match(input, Token.UP, null); 
            }

            }

             finishParamMatch((ParamMatch) currentParam); currentParam = null; 
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "param_match_stmt"


    // $ANTLR start "url_stmt"
    // VladNput/src/org/vladnput/VladWalker.g:119:1: url_stmt : ^( URL url url_body ) ;
    public final void url_stmt() throws RecognitionException {
        VladWalker.url_return url10 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:120:2: ( ^( URL url url_body ) )
            // VladNput/src/org/vladnput/VladWalker.g:120:4: ^( URL url url_body )
            {
            match(input,URL,FOLLOW_URL_in_url_stmt337); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                pushFollow(FOLLOW_url_in_url_stmt343);
                url10=url();

                state._fsp--;

                 currentURL = addURL((url10!=null?url10.value:null), (url10!=null?url10.tree:null)); 
                pushFollow(FOLLOW_url_body_in_url_stmt352);
                url_body();

                state._fsp--;


                match(input, Token.UP, null); 
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "url_stmt"


    // $ANTLR start "url_match_stmt"
    // VladNput/src/org/vladnput/VladWalker.g:126:1: url_match_stmt : ^( URL_MATCH regex url_body ) ;
    public final void url_match_stmt() throws RecognitionException {
        VladWalker.regex_return regex11 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:127:2: ( ^( URL_MATCH regex url_body ) )
            // VladNput/src/org/vladnput/VladWalker.g:127:4: ^( URL_MATCH regex url_body )
            {
            match(input,URL_MATCH,FOLLOW_URL_MATCH_in_url_match_stmt369); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                pushFollow(FOLLOW_regex_in_url_match_stmt375);
                regex11=regex();

                state._fsp--;

                 currentURL = addURLMatch((regex11!=null?regex11.value:null), (regex11!=null?regex11.tree:null)); 
                pushFollow(FOLLOW_url_body_in_url_match_stmt384);
                url_body();

                state._fsp--;


                match(input, Token.UP, null); 
            }

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "url_match_stmt"

    public static class url_return extends TreeRuleReturnScope {
        public String value;
        public CommonTree tree;
    };

    // $ANTLR start "url"
    // VladNput/src/org/vladnput/VladWalker.g:133:1: url returns [String value, CommonTree tree] : ( URL_LITERAL | string );
    public final VladWalker.url_return url() throws RecognitionException {
        VladWalker.url_return retval = new VladWalker.url_return();
        retval.start = input.LT(1);

        CommonTree URL_LITERAL12=null;
        VladWalker.string_return string13 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:134:2: ( URL_LITERAL | string )
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==URL_LITERAL) ) {
                alt8=1;
            }
            else if ( (LA8_0==UP||(LA8_0>=QUESTION && LA8_0<=LBRACE)||LA8_0==CARET||LA8_0==SINGLEQUOTED_STRING||LA8_0==DOUBLEQUOTED_STRING||(LA8_0>=NO_BODY && LA8_0<=NO_CARD_SPEC)||LA8_0==URL_BODY) ) {
                alt8=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }
            switch (alt8) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:134:4: URL_LITERAL
                    {
                    URL_LITERAL12=(CommonTree)match(input,URL_LITERAL,FOLLOW_URL_LITERAL_in_url404); 
                     retval.value = (URL_LITERAL12!=null?URL_LITERAL12.getText():null); retval.tree = URL_LITERAL12; 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:135:4: string
                    {
                    pushFollow(FOLLOW_string_in_url411);
                    string13=string();

                    state._fsp--;

                     retval.value = (string13!=null?string13.value:null); retval.tree = (string13!=null?string13.tree:null); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "url"


    // $ANTLR start "url_body"
    // VladNput/src/org/vladnput/VladWalker.g:138:1: url_body : ( ^( URL_BODY ( url_body_stmt )+ ) | NO_BODY );
    public final void url_body() throws RecognitionException {
        try {
            // VladNput/src/org/vladnput/VladWalker.g:140:2: ( ^( URL_BODY ( url_body_stmt )+ ) | NO_BODY )
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==URL_BODY) ) {
                alt10=1;
            }
            else if ( (LA10_0==NO_BODY) ) {
                alt10=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 10, 0, input);

                throw nvae;
            }
            switch (alt10) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:140:4: ^( URL_BODY ( url_body_stmt )+ )
                    {
                    match(input,URL_BODY,FOLLOW_URL_BODY_in_url_body431); 

                    match(input, Token.DOWN, null); 
                    // VladNput/src/org/vladnput/VladWalker.g:140:15: ( url_body_stmt )+
                    int cnt9=0;
                    loop9:
                    do {
                        int alt9=2;
                        int LA9_0 = input.LA(1);

                        if ( ((LA9_0>=PARAM && LA9_0<=PARAM_MATCH)) ) {
                            alt9=1;
                        }


                        switch (alt9) {
                    	case 1 :
                    	    // VladNput/src/org/vladnput/VladWalker.g:140:15: url_body_stmt
                    	    {
                    	    pushFollow(FOLLOW_url_body_stmt_in_url_body433);
                    	    url_body_stmt();

                    	    state._fsp--;


                    	    }
                    	    break;

                    	default :
                    	    if ( cnt9 >= 1 ) break loop9;
                                EarlyExitException eee =
                                    new EarlyExitException(9, input);
                                throw eee;
                        }
                        cnt9++;
                    } while (true);


                    match(input, Token.UP, null); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:141:4: NO_BODY
                    {
                    match(input,NO_BODY,FOLLOW_NO_BODY_in_url_body440); 

                    }
                    break;

            }
             currentURL = null; 
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "url_body"


    // $ANTLR start "url_body_stmt"
    // VladNput/src/org/vladnput/VladWalker.g:144:1: url_body_stmt : ( param_stmt | param_match_stmt );
    public final void url_body_stmt() throws RecognitionException {
        try {
            // VladNput/src/org/vladnput/VladWalker.g:145:2: ( param_stmt | param_match_stmt )
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==PARAM) ) {
                alt11=1;
            }
            else if ( (LA11_0==PARAM_MATCH) ) {
                alt11=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 11, 0, input);

                throw nvae;
            }
            switch (alt11) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:145:4: param_stmt
                    {
                    pushFollow(FOLLOW_param_stmt_in_url_body_stmt452);
                    param_stmt();

                    state._fsp--;


                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:146:4: param_match_stmt
                    {
                    pushFollow(FOLLOW_param_match_stmt_in_url_body_stmt457);
                    param_match_stmt();

                    state._fsp--;


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "url_body_stmt"


    // $ANTLR start "card_spec"
    // VladNput/src/org/vladnput/VladWalker.g:149:1: card_spec : ( QUESTION | STAR | PLUS | CARET | ^( LBRACE min= INT (max= INT )? ) | NO_CARD_SPEC );
    public final void card_spec() throws RecognitionException {
        CommonTree min=null;
        CommonTree max=null;

        try {
            // VladNput/src/org/vladnput/VladWalker.g:150:2: ( QUESTION | STAR | PLUS | CARET | ^( LBRACE min= INT (max= INT )? ) | NO_CARD_SPEC )
            int alt13=6;
            switch ( input.LA(1) ) {
            case QUESTION:
                {
                alt13=1;
                }
                break;
            case STAR:
                {
                alt13=2;
                }
                break;
            case PLUS:
                {
                alt13=3;
                }
                break;
            case CARET:
                {
                alt13=4;
                }
                break;
            case LBRACE:
                {
                alt13=5;
                }
                break;
            case NO_CARD_SPEC:
                {
                alt13=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 13, 0, input);

                throw nvae;
            }

            switch (alt13) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:150:4: QUESTION
                    {
                    match(input,QUESTION,FOLLOW_QUESTION_in_card_spec469); 
                     currentParam.setCardinality(Cardinality.OPTIONAL); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:151:4: STAR
                    {
                    match(input,STAR,FOLLOW_STAR_in_card_spec476); 
                     currentParam.setCardinality(Cardinality.ZERO_OR_MORE); 

                    }
                    break;
                case 3 :
                    // VladNput/src/org/vladnput/VladWalker.g:152:4: PLUS
                    {
                    match(input,PLUS,FOLLOW_PLUS_in_card_spec484); 
                     currentParam.setCardinality(Cardinality.ONE_OR_MORE); 

                    }
                    break;
                case 4 :
                    // VladNput/src/org/vladnput/VladWalker.g:153:4: CARET
                    {
                    match(input,CARET,FOLLOW_CARET_in_card_spec492); 
                     currentParam.setCardinality(null); 

                    }
                    break;
                case 5 :
                    // VladNput/src/org/vladnput/VladWalker.g:154:4: ^( LBRACE min= INT (max= INT )? )
                    {
                    match(input,LBRACE,FOLLOW_LBRACE_in_card_spec501); 

                    match(input, Token.DOWN, null); 
                    min=(CommonTree)match(input,INT,FOLLOW_INT_in_card_spec505); 
                    // VladNput/src/org/vladnput/VladWalker.g:154:21: (max= INT )?
                    int alt12=2;
                    int LA12_0 = input.LA(1);

                    if ( (LA12_0==INT) ) {
                        alt12=1;
                    }
                    switch (alt12) {
                        case 1 :
                            // VladNput/src/org/vladnput/VladWalker.g:154:22: max= INT
                            {
                            max=(CommonTree)match(input,INT,FOLLOW_INT_in_card_spec510); 

                            }
                            break;

                    }


                    match(input, Token.UP, null); 
                     setCardinality(currentParam, min, max); 

                    }
                    break;
                case 6 :
                    // VladNput/src/org/vladnput/VladWalker.g:156:4: NO_CARD_SPEC
                    {
                    match(input,NO_CARD_SPEC,FOLLOW_NO_CARD_SPEC_in_card_spec524); 
                     currentParam.setCardinality(Cardinality.REQUIRED); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "card_spec"


    // $ANTLR start "param_args"
    // VladNput/src/org/vladnput/VladWalker.g:159:1: param_args : ( type_expr | param_kw_args | NO_ARGS );
    public final void param_args() throws RecognitionException {
        Type type_expr14 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:160:2: ( type_expr | param_kw_args | NO_ARGS )
            int alt14=3;
            switch ( input.LA(1) ) {
            case ID:
            case QNAME:
                {
                alt14=1;
                }
                break;
            case EMPTY_ARGS:
            case KW_ARGS:
                {
                alt14=2;
                }
                break;
            case NO_ARGS:
                {
                alt14=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 14, 0, input);

                throw nvae;
            }

            switch (alt14) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:160:4: type_expr
                    {
                    pushFollow(FOLLOW_type_expr_in_param_args537);
                    type_expr14=type_expr();

                    state._fsp--;

                     currentParam.setType(type_expr14); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:161:4: param_kw_args
                    {
                    pushFollow(FOLLOW_param_kw_args_in_param_args544);
                    param_kw_args();

                    state._fsp--;


                    }
                    break;
                case 3 :
                    // VladNput/src/org/vladnput/VladWalker.g:162:4: NO_ARGS
                    {
                    match(input,NO_ARGS,FOLLOW_NO_ARGS_in_param_args549); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "param_args"


    // $ANTLR start "type_expr"
    // VladNput/src/org/vladnput/VladWalker.g:165:1: type_expr returns [Type value] : (typeName= ID | ^( QNAME (s+= ID )+ ) ) ( type_kw_args[$value] )? ;
    public final Type type_expr() throws RecognitionException {
        Type value = null;

        CommonTree typeName=null;
        CommonTree s=null;
        List list_s=null;

        try {
            // VladNput/src/org/vladnput/VladWalker.g:166:2: ( (typeName= ID | ^( QNAME (s+= ID )+ ) ) ( type_kw_args[$value] )? )
            // VladNput/src/org/vladnput/VladWalker.g:166:4: (typeName= ID | ^( QNAME (s+= ID )+ ) ) ( type_kw_args[$value] )?
            {
            // VladNput/src/org/vladnput/VladWalker.g:166:4: (typeName= ID | ^( QNAME (s+= ID )+ ) )
            int alt16=2;
            int LA16_0 = input.LA(1);

            if ( (LA16_0==ID) ) {
                alt16=1;
            }
            else if ( (LA16_0==QNAME) ) {
                alt16=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 16, 0, input);

                throw nvae;
            }
            switch (alt16) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:166:6: typeName= ID
                    {
                    typeName=(CommonTree)match(input,ID,FOLLOW_ID_in_type_expr569); 
                     value = new Type(typeName, resolveType(typeName)); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:167:5: ^( QNAME (s+= ID )+ )
                    {
                    match(input,QNAME,FOLLOW_QNAME_in_type_expr579); 

                    match(input, Token.DOWN, null); 
                    // VladNput/src/org/vladnput/VladWalker.g:167:13: (s+= ID )+
                    int cnt15=0;
                    loop15:
                    do {
                        int alt15=2;
                        int LA15_0 = input.LA(1);

                        if ( (LA15_0==ID) ) {
                            alt15=1;
                        }


                        switch (alt15) {
                    	case 1 :
                    	    // VladNput/src/org/vladnput/VladWalker.g:167:14: s+= ID
                    	    {
                    	    s=(CommonTree)match(input,ID,FOLLOW_ID_in_type_expr584); 
                    	    if (list_s==null) list_s=new ArrayList();
                    	    list_s.add(s);


                    	    }
                    	    break;

                    	default :
                    	    if ( cnt15 >= 1 ) break loop15;
                                EarlyExitException eee =
                                    new EarlyExitException(15, input);
                                throw eee;
                        }
                        cnt15++;
                    } while (true);


                    match(input, Token.UP, null); 
                     value = new Type((CommonTree) list_s.get(0), parseClass(list_s)); 

                    }
                    break;

            }

            // VladNput/src/org/vladnput/VladWalker.g:169:3: ( type_kw_args[$value] )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( ((LA17_0>=EMPTY_ARGS && LA17_0<=KW_ARGS)) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:169:4: type_kw_args[$value]
                    {
                    pushFollow(FOLLOW_type_kw_args_in_type_expr598);
                    type_kw_args(value);

                    state._fsp--;


                    }
                    break;

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return value;
    }
    // $ANTLR end "type_expr"


    // $ANTLR start "msg_defaults"
    // VladNput/src/org/vladnput/VladWalker.g:172:1: msg_defaults : ^( MESSAGE_DEFAULTS ^( KW_ARGS ( msg_defaults_kw_arg )+ ) ) ;
    public final void msg_defaults() throws RecognitionException {
        try {
            // VladNput/src/org/vladnput/VladWalker.g:173:2: ( ^( MESSAGE_DEFAULTS ^( KW_ARGS ( msg_defaults_kw_arg )+ ) ) )
            // VladNput/src/org/vladnput/VladWalker.g:173:4: ^( MESSAGE_DEFAULTS ^( KW_ARGS ( msg_defaults_kw_arg )+ ) )
            {
            match(input,MESSAGE_DEFAULTS,FOLLOW_MESSAGE_DEFAULTS_in_msg_defaults613); 

            match(input, Token.DOWN, null); 
            match(input,KW_ARGS,FOLLOW_KW_ARGS_in_msg_defaults616); 

            match(input, Token.DOWN, null); 
            // VladNput/src/org/vladnput/VladWalker.g:173:33: ( msg_defaults_kw_arg )+
            int cnt18=0;
            loop18:
            do {
                int alt18=2;
                int LA18_0 = input.LA(1);

                if ( (LA18_0==ID) ) {
                    alt18=1;
                }


                switch (alt18) {
            	case 1 :
            	    // VladNput/src/org/vladnput/VladWalker.g:173:33: msg_defaults_kw_arg
            	    {
            	    pushFollow(FOLLOW_msg_defaults_kw_arg_in_msg_defaults618);
            	    msg_defaults_kw_arg();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    if ( cnt18 >= 1 ) break loop18;
                        EarlyExitException eee =
                            new EarlyExitException(18, input);
                        throw eee;
                }
                cnt18++;
            } while (true);


            match(input, Token.UP, null); 

            match(input, Token.UP, null); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "msg_defaults"


    // $ANTLR start "msg_defaults_kw_arg"
    // VladNput/src/org/vladnput/VladWalker.g:176:1: msg_defaults_kw_arg : ^( ID string ) ;
    public final void msg_defaults_kw_arg() throws RecognitionException {
        CommonTree ID15=null;
        VladWalker.string_return string16 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:177:2: ( ^( ID string ) )
            // VladNput/src/org/vladnput/VladWalker.g:177:4: ^( ID string )
            {
            ID15=(CommonTree)match(input,ID,FOLLOW_ID_in_msg_defaults_kw_arg633); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                pushFollow(FOLLOW_string_in_msg_defaults_kw_arg635);
                string16=string();

                state._fsp--;


                match(input, Token.UP, null); 
            }
             addMessageDefault(ID15, (string16!=null?string16.value:null)); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "msg_defaults_kw_arg"


    // $ANTLR start "param_kw_args"
    // VladNput/src/org/vladnput/VladWalker.g:180:1: param_kw_args : ( ^( KW_ARGS ( param_kw_arg )+ ) | EMPTY_ARGS );
    public final void param_kw_args() throws RecognitionException {
        try {
            // VladNput/src/org/vladnput/VladWalker.g:181:2: ( ^( KW_ARGS ( param_kw_arg )+ ) | EMPTY_ARGS )
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==KW_ARGS) ) {
                alt20=1;
            }
            else if ( (LA20_0==EMPTY_ARGS) ) {
                alt20=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 20, 0, input);

                throw nvae;
            }
            switch (alt20) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:181:4: ^( KW_ARGS ( param_kw_arg )+ )
                    {
                    match(input,KW_ARGS,FOLLOW_KW_ARGS_in_param_kw_args650); 

                    match(input, Token.DOWN, null); 
                    // VladNput/src/org/vladnput/VladWalker.g:181:14: ( param_kw_arg )+
                    int cnt19=0;
                    loop19:
                    do {
                        int alt19=2;
                        int LA19_0 = input.LA(1);

                        if ( (LA19_0==TYPE||LA19_0==ID) ) {
                            alt19=1;
                        }


                        switch (alt19) {
                    	case 1 :
                    	    // VladNput/src/org/vladnput/VladWalker.g:181:14: param_kw_arg
                    	    {
                    	    pushFollow(FOLLOW_param_kw_arg_in_param_kw_args652);
                    	    param_kw_arg();

                    	    state._fsp--;


                    	    }
                    	    break;

                    	default :
                    	    if ( cnt19 >= 1 ) break loop19;
                                EarlyExitException eee =
                                    new EarlyExitException(19, input);
                                throw eee;
                        }
                        cnt19++;
                    } while (true);


                    match(input, Token.UP, null); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:182:4: EMPTY_ARGS
                    {
                    match(input,EMPTY_ARGS,FOLLOW_EMPTY_ARGS_in_param_kw_args660); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "param_kw_args"


    // $ANTLR start "param_kw_arg"
    // VladNput/src/org/vladnput/VladWalker.g:185:1: param_kw_arg : ( ^( TYPE type_expr ) | ^( ID literal ) );
    public final void param_kw_arg() throws RecognitionException {
        CommonTree ID18=null;
        Type type_expr17 = null;

        VladWalker.literal_return literal19 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:186:2: ( ^( TYPE type_expr ) | ^( ID literal ) )
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==TYPE) ) {
                alt21=1;
            }
            else if ( (LA21_0==ID) ) {
                alt21=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 21, 0, input);

                throw nvae;
            }
            switch (alt21) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:186:4: ^( TYPE type_expr )
                    {
                    match(input,TYPE,FOLLOW_TYPE_in_param_kw_arg672); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_type_expr_in_param_kw_arg674);
                    type_expr17=type_expr();

                    state._fsp--;


                    match(input, Token.UP, null); 
                     currentParam.setType(type_expr17); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:187:4: ^( ID literal )
                    {
                    ID18=(CommonTree)match(input,ID,FOLLOW_ID_in_param_kw_arg683); 

                    if ( input.LA(1)==Token.DOWN ) {
                        match(input, Token.DOWN, null); 
                        pushFollow(FOLLOW_literal_in_param_kw_arg685);
                        literal19=literal();

                        state._fsp--;


                        match(input, Token.UP, null); 
                    }
                     addParamKwArg(ID18, (literal19!=null?literal19.value:null)); 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "param_kw_arg"


    // $ANTLR start "type_kw_args"
    // VladNput/src/org/vladnput/VladWalker.g:190:1: type_kw_args[Type type] : ( ^( KW_ARGS ( type_kw_arg[type] )+ ) | EMPTY_ARGS );
    public final void type_kw_args(Type type) throws RecognitionException {
        try {
            // VladNput/src/org/vladnput/VladWalker.g:192:2: ( ^( KW_ARGS ( type_kw_arg[type] )+ ) | EMPTY_ARGS )
            int alt23=2;
            int LA23_0 = input.LA(1);

            if ( (LA23_0==KW_ARGS) ) {
                alt23=1;
            }
            else if ( (LA23_0==EMPTY_ARGS) ) {
                alt23=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 23, 0, input);

                throw nvae;
            }
            switch (alt23) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:192:4: ^( KW_ARGS ( type_kw_arg[type] )+ )
                    {
                    match(input,KW_ARGS,FOLLOW_KW_ARGS_in_type_kw_args707); 

                    match(input, Token.DOWN, null); 
                    // VladNput/src/org/vladnput/VladWalker.g:192:14: ( type_kw_arg[type] )+
                    int cnt22=0;
                    loop22:
                    do {
                        int alt22=2;
                        int LA22_0 = input.LA(1);

                        if ( (LA22_0==ID) ) {
                            alt22=1;
                        }


                        switch (alt22) {
                    	case 1 :
                    	    // VladNput/src/org/vladnput/VladWalker.g:192:15: type_kw_arg[type]
                    	    {
                    	    pushFollow(FOLLOW_type_kw_arg_in_type_kw_args710);
                    	    type_kw_arg(type);

                    	    state._fsp--;


                    	    }
                    	    break;

                    	default :
                    	    if ( cnt22 >= 1 ) break loop22;
                                EarlyExitException eee =
                                    new EarlyExitException(22, input);
                                throw eee;
                        }
                        cnt22++;
                    } while (true);


                    match(input, Token.UP, null); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:193:4: EMPTY_ARGS
                    {
                    match(input,EMPTY_ARGS,FOLLOW_EMPTY_ARGS_in_type_kw_args719); 

                    }
                    break;

            }
             typeArgsComplete(type); 
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "type_kw_args"


    // $ANTLR start "type_kw_arg"
    // VladNput/src/org/vladnput/VladWalker.g:196:1: type_kw_arg[Type type] : ^( ID literal ) ;
    public final void type_kw_arg(Type type) throws RecognitionException {
        CommonTree ID20=null;
        VladWalker.literal_return literal21 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:197:2: ( ^( ID literal ) )
            // VladNput/src/org/vladnput/VladWalker.g:197:4: ^( ID literal )
            {
            ID20=(CommonTree)match(input,ID,FOLLOW_ID_in_type_kw_arg732); 

            if ( input.LA(1)==Token.DOWN ) {
                match(input, Token.DOWN, null); 
                pushFollow(FOLLOW_literal_in_type_kw_arg734);
                literal21=literal();

                state._fsp--;


                match(input, Token.UP, null); 
            }
             addTypeArg(type, ID20, (literal21!=null?literal21.value:null)); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "type_kw_arg"

    public static class literal_return extends TreeRuleReturnScope {
        public Object value;
        public CommonTree tree;
    };

    // $ANTLR start "literal"
    // VladNput/src/org/vladnput/VladWalker.g:200:1: literal returns [Object value, CommonTree tree] : ( string | INT | FLOAT | TRUE | FALSE );
    public final VladWalker.literal_return literal() throws RecognitionException {
        VladWalker.literal_return retval = new VladWalker.literal_return();
        retval.start = input.LT(1);

        CommonTree INT23=null;
        CommonTree FLOAT24=null;
        CommonTree TRUE25=null;
        CommonTree FALSE26=null;
        VladWalker.string_return string22 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:201:2: ( string | INT | FLOAT | TRUE | FALSE )
            int alt24=5;
            switch ( input.LA(1) ) {
            case UP:
            case QUESTION:
            case STAR:
            case PLUS:
            case LBRACE:
            case CARET:
            case SINGLEQUOTED_STRING:
            case DOUBLEQUOTED_STRING:
            case NO_BODY:
            case NO_CARD_SPEC:
            case URL_BODY:
                {
                alt24=1;
                }
                break;
            case INT:
                {
                alt24=2;
                }
                break;
            case FLOAT:
                {
                alt24=3;
                }
                break;
            case TRUE:
                {
                alt24=4;
                }
                break;
            case FALSE:
                {
                alt24=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 24, 0, input);

                throw nvae;
            }

            switch (alt24) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:201:4: string
                    {
                    pushFollow(FOLLOW_string_in_literal753);
                    string22=string();

                    state._fsp--;

                     retval.value = (string22!=null?string22.value:null); retval.tree = (string22!=null?string22.tree:null); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:202:4: INT
                    {
                    INT23=(CommonTree)match(input,INT,FOLLOW_INT_in_literal760); 
                     retval.value = parseInt(INT23); retval.tree = INT23; 

                    }
                    break;
                case 3 :
                    // VladNput/src/org/vladnput/VladWalker.g:203:4: FLOAT
                    {
                    FLOAT24=(CommonTree)match(input,FLOAT,FOLLOW_FLOAT_in_literal767); 
                     retval.value = parseFloat(FLOAT24); retval.tree = FLOAT24; 

                    }
                    break;
                case 4 :
                    // VladNput/src/org/vladnput/VladWalker.g:204:4: TRUE
                    {
                    TRUE25=(CommonTree)match(input,TRUE,FOLLOW_TRUE_in_literal774); 
                     retval.value = Boolean.TRUE; retval.tree = TRUE25; 

                    }
                    break;
                case 5 :
                    // VladNput/src/org/vladnput/VladWalker.g:205:4: FALSE
                    {
                    FALSE26=(CommonTree)match(input,FALSE,FOLLOW_FALSE_in_literal781); 
                     retval.value = Boolean.FALSE; retval.tree = FALSE26; 

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "literal"

    public static class regex_return extends TreeRuleReturnScope {
        public Pattern value;
        public CommonTree tree;
    };

    // $ANTLR start "regex"
    // VladNput/src/org/vladnput/VladWalker.g:208:1: regex returns [Pattern value, CommonTree tree] : string ;
    public final VladWalker.regex_return regex() throws RecognitionException {
        VladWalker.regex_return retval = new VladWalker.regex_return();
        retval.start = input.LT(1);

        VladWalker.string_return string27 = null;


        try {
            // VladNput/src/org/vladnput/VladWalker.g:209:2: ( string )
            // VladNput/src/org/vladnput/VladWalker.g:209:4: string
            {
            pushFollow(FOLLOW_string_in_regex798);
            string27=string();

            state._fsp--;

             retval.value = compileRegex((string27!=null?string27.value:null), (string27!=null?string27.tree:null)); retval.tree = (string27!=null?string27.tree:null); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "regex"

    public static class string_return extends TreeRuleReturnScope {
        public String value;
        public CommonTree tree;
    };

    // $ANTLR start "string"
    // VladNput/src/org/vladnput/VladWalker.g:212:1: string returns [String value, CommonTree tree] : (v= DOUBLEQUOTED_STRING | | v= SINGLEQUOTED_STRING ) ;
    public final VladWalker.string_return string() throws RecognitionException {
        VladWalker.string_return retval = new VladWalker.string_return();
        retval.start = input.LT(1);

        CommonTree v=null;

        try {
            // VladNput/src/org/vladnput/VladWalker.g:213:2: ( (v= DOUBLEQUOTED_STRING | | v= SINGLEQUOTED_STRING ) )
            // VladNput/src/org/vladnput/VladWalker.g:213:4: (v= DOUBLEQUOTED_STRING | | v= SINGLEQUOTED_STRING )
            {
            // VladNput/src/org/vladnput/VladWalker.g:213:4: (v= DOUBLEQUOTED_STRING | | v= SINGLEQUOTED_STRING )
            int alt25=3;
            switch ( input.LA(1) ) {
            case DOUBLEQUOTED_STRING:
                {
                alt25=1;
                }
                break;
            case UP:
            case QUESTION:
            case STAR:
            case PLUS:
            case LBRACE:
            case CARET:
            case NO_BODY:
            case NO_CARD_SPEC:
            case URL_BODY:
                {
                alt25=2;
                }
                break;
            case SINGLEQUOTED_STRING:
                {
                alt25=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }

            switch (alt25) {
                case 1 :
                    // VladNput/src/org/vladnput/VladWalker.g:213:6: v= DOUBLEQUOTED_STRING
                    {
                    v=(CommonTree)match(input,DOUBLEQUOTED_STRING,FOLLOW_DOUBLEQUOTED_STRING_in_string819); 

                    }
                    break;
                case 2 :
                    // VladNput/src/org/vladnput/VladWalker.g:214:4: 
                    {
                    }
                    break;
                case 3 :
                    // VladNput/src/org/vladnput/VladWalker.g:214:6: v= SINGLEQUOTED_STRING
                    {
                    v=(CommonTree)match(input,SINGLEQUOTED_STRING,FOLLOW_SINGLEQUOTED_STRING_in_string828); 

                    }
                    break;

            }

             retval.value = parseString(v); retval.tree = v; 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "string"

    // Delegated rules


 

    public static final BitSet FOLLOW_stmt_in_start51 = new BitSet(new long[]{0x0000000000003BA0L});
    public static final BitSet FOLLOW_EOF_in_start54 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_include_stmt_in_stmt65 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_options_stmt_in_stmt70 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_stmt_in_stmt75 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_param_stmt_in_stmt80 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_param_match_stmt_in_stmt85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_url_stmt_in_stmt90 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_url_match_stmt_in_stmt95 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INCLUDE_in_include_stmt107 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_string_in_include_stmt115 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ANGLE_STRING_in_include_stmt126 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_OPTIONS_in_options_stmt165 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_option_in_options_stmt167 = new BitSet(new long[]{0x0000040000000048L});
    public static final BitSet FOLLOW_OPTIONS_in_options_stmt174 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_OPTION_in_option187 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_ID_in_option189 = new BitSet(new long[]{0x0000000328000410L});
    public static final BitSet FOLLOW_literal_in_option191 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_msg_defaults_in_option199 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TYPE_in_type_stmt211 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_ID_in_type_stmt213 = new BitSet(new long[]{0x0000080080000000L});
    public static final BitSet FOLLOW_type_expr_in_type_stmt215 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_PARAM_in_param_stmt236 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_param_id_in_param_stmt242 = new BitSet(new long[]{0x0000020002F00000L});
    public static final BitSet FOLLOW_card_spec_in_param_stmt248 = new BitSet(new long[]{0x000008E080000000L});
    public static final BitSet FOLLOW_param_args_in_param_stmt254 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ID_in_param_id271 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_string_in_param_id279 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PARAM_MATCH_in_param_match_stmt299 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_regex_in_param_match_stmt305 = new BitSet(new long[]{0x0000020002F00000L});
    public static final BitSet FOLLOW_card_spec_in_param_match_stmt314 = new BitSet(new long[]{0x000008E080000000L});
    public static final BitSet FOLLOW_param_args_in_param_match_stmt320 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_URL_in_url_stmt337 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_url_in_url_stmt343 = new BitSet(new long[]{0x0000110000000000L});
    public static final BitSet FOLLOW_url_body_in_url_stmt352 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_URL_MATCH_in_url_match_stmt369 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_regex_in_url_match_stmt375 = new BitSet(new long[]{0x0000110000000000L});
    public static final BitSet FOLLOW_url_body_in_url_match_stmt384 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_URL_LITERAL_in_url404 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_string_in_url411 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_URL_BODY_in_url_body431 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_url_body_stmt_in_url_body433 = new BitSet(new long[]{0x0000000000000308L});
    public static final BitSet FOLLOW_NO_BODY_in_url_body440 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_param_stmt_in_url_body_stmt452 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_param_match_stmt_in_url_body_stmt457 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_QUESTION_in_card_spec469 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STAR_in_card_spec476 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PLUS_in_card_spec484 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_CARET_in_card_spec492 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LBRACE_in_card_spec501 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_INT_in_card_spec505 = new BitSet(new long[]{0x0000000200000008L});
    public static final BitSet FOLLOW_INT_in_card_spec510 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_NO_CARD_SPEC_in_card_spec524 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_type_expr_in_param_args537 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_param_kw_args_in_param_args544 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NO_ARGS_in_param_args549 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_type_expr569 = new BitSet(new long[]{0x0000006000000002L});
    public static final BitSet FOLLOW_QNAME_in_type_expr579 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_ID_in_type_expr584 = new BitSet(new long[]{0x0000000080000008L});
    public static final BitSet FOLLOW_type_kw_args_in_type_expr598 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_MESSAGE_DEFAULTS_in_msg_defaults613 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_KW_ARGS_in_msg_defaults616 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_msg_defaults_kw_arg_in_msg_defaults618 = new BitSet(new long[]{0x0000000080000008L});
    public static final BitSet FOLLOW_ID_in_msg_defaults_kw_arg633 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_string_in_msg_defaults_kw_arg635 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_KW_ARGS_in_param_kw_args650 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_param_kw_arg_in_param_kw_args652 = new BitSet(new long[]{0x0000000080000808L});
    public static final BitSet FOLLOW_EMPTY_ARGS_in_param_kw_args660 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TYPE_in_param_kw_arg672 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_type_expr_in_param_kw_arg674 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_ID_in_param_kw_arg683 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_literal_in_param_kw_arg685 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_KW_ARGS_in_type_kw_args707 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_type_kw_arg_in_type_kw_args710 = new BitSet(new long[]{0x0000000080000008L});
    public static final BitSet FOLLOW_EMPTY_ARGS_in_type_kw_args719 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ID_in_type_kw_arg732 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_literal_in_type_kw_arg734 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_string_in_literal753 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_in_literal760 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FLOAT_in_literal767 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRUE_in_literal774 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_literal781 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_string_in_regex798 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DOUBLEQUOTED_STRING_in_string819 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_SINGLEQUOTED_STRING_in_string828 = new BitSet(new long[]{0x0000000000000002L});

}