/* Copyright 2009 Patrick Higgins 
 *
 * This file is part of VladNput.
 *
 * VladNput is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * VladNput is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with VladNput.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.vladnput;

import java.io.File;
import java.io.PrintWriter;
import java.io.StringWriter;

import junit.framework.AssertionFailedError;
import junit.framework.TestCase;

public class IncludeTest extends TestCase {
	
	public void testRecursive() throws Exception {
		try {
			VladConfig.parseResource("semantics/include/recurse/1.vlad");
			throw new AssertionFailedError("ParseException not thrown");
		}
		catch (ParseException e) {
			StringWriter sw = new StringWriter();
			PrintWriter pw = new PrintWriter(sw);
			e.getErrors().reportErrors(pw);
			pw.close();
			String[] expected = {
				"classes/semantics/include/recurse/3.vlad:1:8 recursive include: \"1.vlad\"",
			};
			TestUtil.logCompare(expected, sw.toString());
		}
	}

	public void testRecursiveResource() throws Exception {
		try {
			VladConfig.parseResource("semantics/include/recurse/1r.vlad");
			throw new AssertionFailedError("ParseException not thrown");
		}
		catch (ParseException e) {
			StringWriter sw = new StringWriter();
			PrintWriter pw = new PrintWriter(sw);
			e.getErrors().reportErrors(pw);
			pw.close();
			String[] expected = {
				"resource:semantics/include/recurse/3r.vlad:1:8 recursive include: <semantics/include/recurse/1r.vlad>",
			};
			TestUtil.logCompare(expected, sw.toString());
		}
	}

}
